{   DynTFT  - graphic components for microcontrollers
    Copyright (C) 2017 VCC
    release date: 29 Dec 2017
    author: VCC

    This file is part of DynTFT project.

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the "Software"),
    to deal in the Software without restriction, including without limitation
    the rights to use, copy, modify, merge, publish, distribute, sublicense,
    and/or sell copies of the Software, and to permit persons to whom the
    Software is furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included
    in all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
    DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
    OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
}

//Generated by DynTFTCodeGen.


unit DynTFTGUIObjects;

{$IFNDEF IsMCU}
  {$DEFINE IsDesktop}
{$ENDIF}

{$IFDEF IsDesktop}
interface
{$ENDIF}

uses
  DynTFTTypes, DynTFTConsts,

//<DynTFTComponents>
  DynTFTButton,
  DynTFTArrowButton,
  DynTFTPanel,
  DynTFTCheckBox,
  DynTFTScrollBar,
  DynTFTItems,
  DynTFTListBox,
  DynTFTLabel,
  DynTFTRadioButton,
  DynTFTRadioGroup,
  DynTFTTabButton,
  DynTFTPageControl,
  DynTFTEdit,
  DynTFTKeyButton,
  DynTFTVirtualKeyboard,
  DynTFTComboBox,
  DynTFTTrackBar,
  DynTFTProgressBar,
  DynTFTMessageBox
//<EndOfDynTFTComponents> - Do not remove or modify this line!


  {$I DynTFTGUIAdditionalUnits.inc}
  ;


// Project name: GUI_Example_480x272.dyntftcg //Do not delete or modify this line!

var
  PageControl1: PDynTFTPageControl;
  btn1: PDynTFTButton;
  btn2: PDynTFTButton;
  Arrow1: PDynTFTArrowButton;
  Arrow2: PDynTFTArrowButton;
  Arrow3: PDynTFTArrowButton;
  Arrow4: PDynTFTArrowButton;
  Panel1: PDynTFTPanel;
  Arrow5: PDynTFTArrowButton;
  Arrow6: PDynTFTArrowButton;
  Arrow7: PDynTFTArrowButton;
  Arrow8: PDynTFTArrowButton;
  btn3: PDynTFTButton;
  btn4: PDynTFTButton;
  CheckBox1: PDynTFTCheckBox;
  CheckBox2: PDynTFTCheckBox;
  CheckBox3: PDynTFTCheckBox;
  ScrollBar1: PDynTFTScrollBar;
  ScrollBar2: PDynTFTScrollBar;
  ListBox1: PDynTFTListBox;
  ListBox3: PDynTFTListBox;
  DynTFTButton0: PDynTFTButton;
  lbl1: PDynTFTLabel;
  lbl2: PDynTFTLabel;
  lbl3: PDynTFTLabel;
  lbl4: PDynTFTLabel;
  rdgrpTest: PDynTFTRadioGroup;
  rdgrpTest1: PDynTFTRadioGroup;
  vkTest: PDynTFTVirtualKeyboard;
  Edit1: PDynTFTEdit;
  ComboBox1: PDynTFTComboBox;
  ComboBox2: PDynTFTComboBox;
  Label4: PDynTFTLabel;
  Label5: PDynTFTLabel;
  ListBox2: PDynTFTListBox;
  ListBox4: PDynTFTListBox;
  TrackBar1: PDynTFTTrackBar;
  TrackBar2: PDynTFTTrackBar;
  ProgressBar1: PDynTFTProgressBar;
  ProgressBar2: PDynTFTProgressBar;
  btnShowMessageBox: PDynTFTButton;

//RadioGroup code
type
  TRadioButtonCaption = string[CMaxRadioButtonStringLength];
  TRadioButtonCaptionArr = array{$IFDEF IsMCU}[0..0]{$ENDIF} of TRadioButtonCaption;

procedure PDynTFTRadioGroup_CreateAllRadioButtons(Left, Top, Width, Height, ButtonCount: Integer; Parent: PDynTFTRadioGroup; {$IFDEF IsMCU}var Captions: TRadioButtonCaptionArr{$ELSE} const Captions: array of TRadioButtonCaption{$ENDIF});

//PageControl code
type
  TTabButtonCaption = string[CMaxTabButtonStringLength];
  TTabButtonCaptionArr = array{$IFDEF IsMCU}[0..0]{$ENDIF} of TTabButtonCaption;
  TTabButtonIntegerArr = array{$IFDEF IsMCU}[0..0]{$ENDIF} of Integer;

procedure PDynTFTPageControl_CreateAllTabButtonsAsHorizontal(Left, Top, Height, PageCount: Integer; {$IFDEF IsMCU}var Lefts, Widths: TTabButtonIntegerArr {$ELSE} const Lefts, Widths: array of Integer{$ENDIF}; Parent: PDynTFTPageControl; {$IFDEF IsMCU}var Captions: TTabButtonCaptionArr{$ELSE} const Captions: array of TTabButtonCaption{$ENDIF});
procedure PDynTFTPageControl_CreateAllTabButtonsAsVertical(Left, Top, Width, Height, PageCount: Integer; Parent: PDynTFTPageControl; {$IFDEF IsMCU}var Captions: TTabButtonCaptionArr{$ELSE} const Captions: array of TTabButtonCaption{$ENDIF});


const
  // DynTFTRadioGroup
  CrdgrpTest_Captions: array[0..8 - 1] of TRadioButtonCaption = ('first', 'second', 'third', 'fourth', 'fifth', 'sixth', 'seventh', 'eighth');
  CrdgrpTest1_Captions: array[0..8 - 1] of TRadioButtonCaption = ('one', 'two', 'three', 'four', 'five', 'six', 'seven', 'eight');

  // DynTFTPageControl
  CPageControl1_Captions: array[0..6 - 1] of TTabButtonCaption = ('Tab1', 'Tab2', 'Tab3', 'Tab4', 'Tab5', 'Tab6');
  CPageControl1_ButtonLefts: array[0..6 - 1] of Integer = (0, 47, 94, 141, 188, 235);
  CPageControl1_ButtonWidths: array[0..6 - 1] of Integer = (46, 46, 46, 46, 46, 46);


const
  C_btn1_Caption = 'Button 1';
  C_btn2_Caption = 'Button 2';
  C_Panel1_Caption = 'Panel 1';
  C_btn3_Caption = 'Disabled Button 3';
  C_btn4_Caption = 'Disabled Button 4';
  C_CheckBox1_Caption = 'CheckBox 1';
  C_CheckBox2_Caption = 'CheckBox 2';
  C_CheckBox3_Caption = 'CheckBox 3';
  C_ListBox1_Items_Strings_Item_0 = 'one';
  C_ListBox1_Items_Strings_Item_1 = 'two';
  C_ListBox1_Items_Strings_Item_2 = 'three';
  C_ListBox1_Items_Strings_Item_3 = 'four';
  C_ListBox1_Items_Strings_Item_4 = 'five';
  C_ListBox1_Items_Strings_Item_5 = 'six';
  C_ListBox1_Items_Strings_Item_6 = 'seven';
  C_ListBox1_Items_Strings_Item_7 = 'eight';
  C_ListBox1_Items_Strings_Item_8 = 'nine';
  C_ListBox1_Items_Strings_Item_9 = 'ten';
  C_ListBox3_Items_Strings_Item_0 = 'one';
  C_ListBox3_Items_Strings_Item_1 = 'two';
  C_ListBox3_Items_Strings_Item_2 = 'three';
  C_ListBox3_Items_Strings_Item_3 = 'four';
  C_ListBox3_Items_Strings_Item_4 = 'five';
  C_ListBox3_Items_Strings_Item_5 = 'six';
  C_ListBox3_Items_Strings_Item_6 = 'seven';
  C_ListBox3_Items_Strings_Item_7 = 'eight';
  C_ListBox3_Items_Strings_Item_8 = 'nine';
  C_ListBox3_Items_Strings_Item_9 = 'ten';
  C_DynTFTButton0_Caption = 'btn0';
  C_lbl1_Caption = 'Label 1';
  C_lbl2_Caption = 'Label 2';
  C_lbl3_Caption = 'Label 3';
  C_lbl4_Caption = 'Label 4';
  C_rdgrpTest_Caption = 'Radio Group 1';
  C_rdgrpTest1_Caption = 'Radio Group 2';
  C_Edit1_Text = 'Edit1';
  C_ComboBox1_ListBox_Items_Strings_Item_0 = 'one';
  C_ComboBox1_ListBox_Items_Strings_Item_1 = 'two';
  C_ComboBox1_ListBox_Items_Strings_Item_2 = 'three';
  C_ComboBox1_ListBox_Items_Strings_Item_3 = 'four';
  C_ComboBox1_ListBox_Items_Strings_Item_4 = 'five';
  C_ComboBox1_ListBox_Items_Strings_Item_5 = 'six';
  C_ComboBox1_ListBox_Items_Strings_Item_6 = 'seven';
  C_ComboBox1_ListBox_Items_Strings_Item_7 = 'eight';
  C_ComboBox1_ListBox_Items_Strings_Item_8 = 'nine';
  C_ComboBox1_ListBox_Items_Strings_Item_9 = 'ten';
  C_ComboBox2_ListBox_Items_Strings_Item_0 = 'one';
  C_ComboBox2_ListBox_Items_Strings_Item_1 = 'two';
  C_ComboBox2_ListBox_Items_Strings_Item_2 = 'three';
  C_ComboBox2_ListBox_Items_Strings_Item_3 = 'four';
  C_ComboBox2_ListBox_Items_Strings_Item_4 = 'five';
  C_ComboBox2_ListBox_Items_Strings_Item_5 = 'six';
  C_ComboBox2_ListBox_Items_Strings_Item_6 = 'seven';
  C_ComboBox2_ListBox_Items_Strings_Item_7 = 'eight';
  C_ComboBox2_ListBox_Items_Strings_Item_8 = 'nine';
  C_ComboBox2_ListBox_Items_Strings_Item_9 = 'ten';
  C_Label4_Caption = 'Editable';
  C_Label5_Caption = 'Selectable only';
  C_ListBox2_Items_Strings_Item_0 = 'one';
  C_ListBox2_Items_Strings_Item_1 = 'two';
  C_ListBox2_Items_Strings_Item_2 = 'three';
  C_ListBox2_Items_Strings_Item_3 = 'four';
  C_ListBox2_Items_Strings_Item_4 = 'five';
  C_ListBox2_Items_Strings_Item_5 = 'six';
  C_ListBox2_Items_Strings_Item_6 = 'seven';
  C_ListBox2_Items_Strings_Item_7 = 'eight';
  C_ListBox2_Items_Strings_Item_8 = 'nine';
  C_ListBox2_Items_Strings_Item_9 = 'ten';
  C_ListBox4_Items_Strings_Item_0 = 'one';
  C_ListBox4_Items_Strings_Item_1 = 'two';
  C_ListBox4_Items_Strings_Item_2 = 'three';
  C_ListBox4_Items_Strings_Item_3 = 'four';
  C_ListBox4_Items_Strings_Item_4 = 'five';
  C_ListBox4_Items_Strings_Item_5 = 'six';
  C_ListBox4_Items_Strings_Item_6 = 'seven';
  C_ListBox4_Items_Strings_Item_7 = 'eight';
  C_ListBox4_Items_Strings_Item_8 = 'nine';
  C_ListBox4_Items_Strings_Item_9 = 'ten';
  C_btnShowMessageBox_Caption = 'Message Box';

  {$IFDEF RTTIREG}
      CAllCreatedBinComponents: array[0..0] of ^PDynTFTBaseComponent = (nil);  // No binary component with global variable.
  {$ENDIF} // RTTIREG

implementation

procedure PDynTFTRadioGroup_CreateRadioButton(Left, Top, Width, Height: Integer; {$IFDEF IsMCU} var {$ENDIF}Caption: string; Parent: PDynTFTRadioGroup);
var
  radbtn: PDynTFTRadioButton;
begin
  radbtn := DynTFTRadioButton_Create(Parent^.BaseProps.ScreenIndex, Left, Top, Width, Height);
  radbtn^.Caption := Caption;
  DynTFTAddRadioButtonToRadioGroup(Parent, radbtn);
end;

procedure PDynTFTRadioGroup_CreateAllRadioButtons(Left, Top, Width, Height, ButtonCount: Integer; Parent: PDynTFTRadioGroup; {$IFDEF IsMCU}var Captions: TRadioButtonCaptionArr{$ELSE} const Captions: array of TRadioButtonCaption{$ENDIF});
var
  i, ButtonCount_1: Integer;
begin
  ButtonCount_1 := ButtonCount - 1;
  for i := 0 to ButtonCount_1 do
    PDynTFTRadioGroup_CreateRadioButton(Left, Top + i * Height, Width, Height, Captions[i], Parent);
end;

procedure PDynTFTPageControl_CreateTabButton(Left, Top, Width, Height: Integer; {$IFDEF IsMCU} var {$ENDIF}Caption: string; Parent: PDynTFTPageControl);
var
  tabbtn: PDynTFTTabButton;
begin
  tabbtn := DynTFTTabButton_Create(Parent^.BaseProps.ScreenIndex, Left, Top, Width, Height);
  tabbtn^.Caption := Caption;
  DynTFTAddTabButtonToPageControl(Parent, tabbtn);
end;

procedure PDynTFTPageControl_CreateAllTabButtonsAsHorizontal(Left, Top, Height, PageCount: Integer; {$IFDEF IsMCU}var Lefts, Widths: TTabButtonIntegerArr {$ELSE} const Lefts, Widths: array of Integer{$ENDIF}; Parent: PDynTFTPageControl; {$IFDEF IsMCU}var Captions: TTabButtonCaptionArr{$ELSE} const Captions: array of TTabButtonCaption{$ENDIF});
var
  i, ButtonCount_1: Integer;
begin
  ButtonCount_1 := PageCount - 1;
  for i := 0 to ButtonCount_1 do

    PDynTFTPageControl_CreateTabButton(Left + Lefts[i], Top, Widths[i], Height, Captions[i], Parent);
end;

procedure PDynTFTPageControl_CreateAllTabButtonsAsVertical(Left, Top, Width, Height, PageCount: Integer; Parent: PDynTFTPageControl; {$IFDEF IsMCU}var Captions: TTabButtonCaptionArr{$ELSE} const Captions: array of TTabButtonCaption{$ENDIF});
var
  i, ButtonCount_1: Integer;
begin
  ButtonCount_1 := PageCount - 1;
  for i := 0 to ButtonCount_1 do
    PDynTFTPageControl_CreateTabButton(Left, Top + i * Height, Width, Height, Captions[i], Parent);
end;

end.
