{   DynTFT  - graphic components for microcontrollers
    Copyright (C) 2017 VCC
    release date: 29 Dec 2017
    author: VCC

    This file is part of DynTFT project.

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the "Software"),
    to deal in the Software without restriction, including without limitation
    the rights to use, copy, modify, merge, publish, distribute, sublicense,
    and/or sell copies of the Software, and to permit persons to whom the
    Software is furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included
    in all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
    DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
    OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
}

//Generated by DynTFTCodeGen.


unit DynTFTGUIObjects;

{$IFNDEF IsMCU}
  {$DEFINE IsDesktop}
{$ENDIF}

{$IFDEF IsDesktop}
interface
{$ENDIF}

uses
  DynTFTTypes, DynTFTConsts,

//<DynTFTComponents>
  DynTFTButton,
  DynTFTArrowButton,
  DynTFTPanel,
  DynTFTCheckBox,
  DynTFTScrollBar,
  DynTFTItems,
  DynTFTListBox,
  DynTFTLabel,
  DynTFTRadioButton,
  DynTFTRadioGroup,
  DynTFTTabButton,
  DynTFTPageControl,
  DynTFTEdit,
  DynTFTKeyButton,
  DynTFTVirtualKeyboard,
  DynTFTComboBox,
  DynTFTTrackBar,
  DynTFTProgressBar,
  DynTFTMessageBox
//<EndOfDynTFTComponents> - Do not remove or modify this line!


  {$I DynTFTGUIAdditionalUnits.inc}
  ;


// Project name: GUI_Example_480x272_RTTI.dyntftcg //Do not delete or modify this line!

var
  PageControl1: PDynTFTPageControl;
  lblRTTIDataSrcInfo: PDynTFTLabel;
  btn1: PDynTFTButton;  //created by First
  btn2: PDynTFTButton;  //created by First
  Arrow1: PDynTFTArrowButton;  //created by First
  Arrow2: PDynTFTArrowButton;  //created by First
  Arrow3: PDynTFTArrowButton;  //created by First
  Arrow4: PDynTFTArrowButton;  //created by First
  Panel1: PDynTFTPanel;  //created by First
  Arrow5: PDynTFTArrowButton;  //created by First
  Arrow6: PDynTFTArrowButton;  //created by First
  Arrow7: PDynTFTArrowButton;  //created by First
  Arrow8: PDynTFTArrowButton;  //created by First
  btn3: PDynTFTButton;  //created by First
  btn4: PDynTFTButton;  //created by First
  Arrow9: PDynTFTArrowButton;  //created by First
  CheckBox1: PDynTFTCheckBox;  //created by Second
  CheckBox2: PDynTFTCheckBox;  //created by Second
  CheckBox3: PDynTFTCheckBox;  //created by Second
  ScrollBar1: PDynTFTScrollBar;  //created by Second
  ScrollBar2: PDynTFTScrollBar;  //created by Second
  ListBox1: PDynTFTListBox;  //created by Second
  ListBox3: PDynTFTListBox;  //created by Second
  DynTFTButton0: PDynTFTButton;  //created by Second
  lbl1: PDynTFTLabel;  //created by Third
  lbl2: PDynTFTLabel;  //created by Third
  lbl3: PDynTFTLabel;  //created by Third
  lbl4: PDynTFTLabel;  //created by Third
  rdgrpTest: PDynTFTRadioGroup;  //created by Third
  rdgrpTest1: PDynTFTRadioGroup;  //created by Third
  vkTest: PDynTFTVirtualKeyboard;  //created by Fourth
  Edit1: PDynTFTEdit;  //created by Fourth
  ComboBox1: PDynTFTComboBox;  //created by Fifth
  ComboBox2: PDynTFTComboBox;  //created by Fifth
  Label4: PDynTFTLabel;  //created by Fifth
  Label5: PDynTFTLabel;  //created by Fifth
  ListBox2: PDynTFTListBox;  //created by Fifth
  ListBox4: PDynTFTListBox;  //created by Fifth
  TrackBar1: PDynTFTTrackBar;  //created by Sixth
  TrackBar2: PDynTFTTrackBar;  //created by Sixth
  ProgressBar1: PDynTFTProgressBar;  //created by Sixth
  ProgressBar2: PDynTFTProgressBar;  //created by Sixth
  btnShowMessageBox: PDynTFTButton;  //created by Sixth

//RadioGroup code
type
  TRadioButtonCaption = string[CMaxRadioButtonStringLength];
  TRadioButtonCaptionArr = array{$IFDEF IsMCU}[0..0]{$ENDIF} of TRadioButtonCaption;

procedure PDynTFTRadioGroup_CreateAllRadioButtons(Left, Top, Width, Height, ButtonCount: Integer; Parent: PDynTFTRadioGroup; {$IFDEF IsMCU}var Captions: TRadioButtonCaptionArr{$ELSE} const Captions: array of TRadioButtonCaption{$ENDIF});

//PageControl code
type
  TTabButtonCaption = string[CMaxTabButtonStringLength];
  TTabButtonCaptionArr = array{$IFDEF IsMCU}[0..0]{$ENDIF} of TTabButtonCaption;
  TTabButtonIntegerArr = array{$IFDEF IsMCU}[0..0]{$ENDIF} of Integer;

procedure PDynTFTPageControl_CreateAllTabButtonsAsHorizontal(Left, Top, Height, PageCount: Integer; {$IFDEF IsMCU}var Lefts, Widths: TTabButtonIntegerArr {$ELSE} const Lefts, Widths: array of Integer{$ENDIF}; Parent: PDynTFTPageControl; {$IFDEF IsMCU}var Captions: TTabButtonCaptionArr{$ELSE} const Captions: array of TTabButtonCaption{$ENDIF});
procedure PDynTFTPageControl_CreateAllTabButtonsAsVertical(Left, Top, Width, Height, PageCount: Integer; Parent: PDynTFTPageControl; {$IFDEF IsMCU}var Captions: TTabButtonCaptionArr{$ELSE} const Captions: array of TTabButtonCaption{$ENDIF});


const
  // DynTFTRadioGroup
  CrdgrpTest_Captions: array[0..8 - 1] of TRadioButtonCaption = ('first', 'second', 'third', 'fourth', 'fifth', 'sixth', 'seventh', 'eighth');
  CrdgrpTest1_Captions: array[0..8 - 1] of TRadioButtonCaption = ('one', 'two', 'three', 'four', 'five', 'six', 'seven', 'eight');

  // DynTFTPageControl
  CPageControl1_Captions: array[0..6 - 1] of TTabButtonCaption = ('Tab1', 'Tab2', 'Tab3', 'Tab4', 'Tab5', 'Tab6');
  CPageControl1_ButtonLefts: array[0..6 - 1] of Integer = (0, 47, 94, 141, 188, 235);
  CPageControl1_ButtonWidths: array[0..6 - 1] of Integer = (46, 46, 46, 46, 46, 46);


const
  C_lblRTTIDataSrcInfo_Caption = 'DataSrc';
  C_rdgrpTest_Caption = 'Radio Group 1';
  C_rdgrpTest1_Caption = 'Radio Group 2';


{$IFDEF RTTIREG}
  {$IFDEF IsDesktop} {$IFDEF DesktopApp_D2006} // Profile: "DesktopApp_D2006"   HandlersLocation: Lst file
    C_RTTI_CreateInstructionData: array[0..480] of DWord = (
      $0400000E,   //Set build number to 14

      $01014001, $001D0009, $0028006E,   //create btn1(1, 9, 29, 110, 40)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03018008, $74747542, $31206E6F,   //set property:  "Caption" of "STRING" to "Button 1".   Property index: 0
      $03010104, $006FAD0B,   //set property:  "Font_Color" of "TCOLOR" to "006FAD0B".   Property index: 1

      $01014001, $001D0169, $0028006E,   //create btn2(1, 361, 29, 110, 40)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03018008, $74747542, $32206E6F,   //set property:  "Caption" of "STRING" to "Button 2".   Property index: 0
      $03010104, $006FAD0B,   //set property:  "Font_Color" of "TCOLOR" to "006FAD0B".   Property index: 1

      $01024001, $00220089, $001E001E,   //create Arrow1(1, 137, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $006FAD0B,   //set property:  "Color" of "TCOLOR" to "006FAD0B".   Property index: 0
      $03020101, $00000002,   //set property:  "ArrowDir" of "BYTE" to "CLeftArrow".   Property index: 1

      $01024001, $002200B1, $001E001E,   //create Arrow2(1, 177, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $006FAD0B,   //set property:  "Color" of "TCOLOR" to "006FAD0B".   Property index: 0
      $03020101, $00000003,   //set property:  "ArrowDir" of "BYTE" to "CRightArrow".   Property index: 1

      $01024001, $0022010F, $001E001E,   //create Arrow3(1, 271, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $006FAD0B,   //set property:  "Color" of "TCOLOR" to "006FAD0B".   Property index: 0

      $01024001, $00220139, $001E001E,   //create Arrow4(1, 313, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $006FAD0B,   //set property:  "Color" of "TCOLOR" to "006FAD0B".   Property index: 0
      $03020101, $00000001,   //set property:  "ArrowDir" of "BYTE" to "CDownArrow".   Property index: 1

      $01034001, $00550069, $00620112,   //create Panel1(1, 105, 85, 274, 98)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03030004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03038107, $656E6150, $0031206C,   //set property:  "Caption" of "STRING" to "Panel 1".   Property index: 1
      $03030204, $006FAD6F,   //set property:  "Color" of "TCOLOR" to "006FAD6F".   Property index: 2
      $03030304, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 3

      $01024001, $00A50011, $002D002D,   //create Arrow5(1, 17, 165, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00A0E632,   //set property:  "Color" of "TCOLOR" to "00A0E632".   Property index: 0

      $01024001, $00DD0011, $002D002D,   //create Arrow6(1, 17, 221, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00A0E632,   //set property:  "Color" of "TCOLOR" to "00A0E632".   Property index: 0
      $03020101, $00000001,   //set property:  "ArrowDir" of "BYTE" to "CDownArrow".   Property index: 1

      $01024001, $00A501A1, $002D002D,   //create Arrow7(1, 417, 165, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00A0E632,   //set property:  "Color" of "TCOLOR" to "00A0E632".   Property index: 0
      $03020101, $00000002,   //set property:  "ArrowDir" of "BYTE" to "CLeftArrow".   Property index: 1

      $01024001, $00DD01A1, $002D002D,   //create Arrow8(1, 417, 221, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00A0E632,   //set property:  "Color" of "TCOLOR" to "00A0E632".   Property index: 0
      $03020101, $00000003,   //set property:  "ArrowDir" of "BYTE" to "CRightArrow".   Property index: 1

      $01014001, $00BD00A9, $00230094,   //create btn3(1, 169, 189, 148, 35)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03010201, $00000000,   //set property:  "BaseProps.Enabled" of "BYTE" to "0".   Property index: 2
      $03010304, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 3
      $03018011, $61736944, $64656C62, $74754220, $206E6F74, $00000033,   //set property:  "Caption" of "STRING" to "Disabled Button 3".   Property index: 0

      $01014001, $00E500A9, $00230094,   //create btn4(1, 169, 229, 148, 35)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03010201, $00000000,   //set property:  "BaseProps.Enabled" of "BYTE" to "0".   Property index: 2
      $03010304, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 3
      $03018011, $61736944, $64656C62, $74754220, $206E6F74, $00000034,   //set property:  "Caption" of "STRING" to "Disabled Button 4".   Property index: 0

      $01024001, $001D00D8, $002D002D,   //create Arrow9(1, 216, 29, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00FFEFEF,   //set property:  "Color" of "TCOLOR" to "00FFEFEF".   Property index: 0
      $03020101, $00000004,   //set property:  "ArrowDir" of "BYTE" to "CUndefinedArrow".   Property index: 1

      $01044102, $001D0019, $0019008C,   //create CheckBox1(2, 25, 29, 140, 25)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0304800A, $63656843, $786F426B, $00003120,   //set property:  "Caption" of "STRING" to "CheckBox 1".   Property index: 0
      $03040104, $00BE8296,   //set property:  "Color" of "TCOLOR" to "00BE8296".   Property index: 1
      $03040204, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 2

      $01044102, $00450019, $0019008C,   //create CheckBox2(2, 25, 69, 140, 25)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0304800A, $63656843, $786F426B, $00003220,   //set property:  "Caption" of "STRING" to "CheckBox 2".   Property index: 0
      $03040104, $00BE8296,   //set property:  "Color" of "TCOLOR" to "00BE8296".   Property index: 1
      $03040204, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 2

      $01044102, $001D00F9, $0019008C,   //create CheckBox3(2, 249, 29, 140, 25)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03040301, $00000000,   //set property:  "BaseProps.Enabled" of "BYTE" to "0".   Property index: 3
      $0304800A, $63656843, $786F426B, $00003320,   //set property:  "Caption" of "STRING" to "CheckBox 3".   Property index: 0
      $03040104, $00BE8296,   //set property:  "Color" of "TCOLOR" to "00BE8296".   Property index: 1
      $03040204, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 2

      $01054102, $00ED0019, $00140199,   //create ScrollBar1(2, 25, 237, 409, 20)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0

      $01054102, $001D01B9, $00D00014,   //create ScrollBar2(2, 441, 29, 20, 208)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03050001, $00000001,   //set property:  "Direction" of "BYTE" to "CScrollBarVertDir".   Property index: 0

      $01074102, $006D0019, $006F008C,   //create ListBox1(2, 25, 109, 140, 111)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03070004, $00FAAFBE,   //set property:  "Items^.BackgroundColor" of "TCOLOR" to "00FAAFBE".   Property index: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C04, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01074102, $006D00F9, $006F008C,   //create ListBox3(2, 249, 109, 140, 111)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C04, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01014102, $003F00F9, $0026008C,   //create DynTFTButton0(2, 249, 63, 140, 38)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03018004, $306E7462,   //set property:  "Caption" of "STRING" to "btn0".   Property index: 0
      $03010404, $00477938,   //set property:  "ActiveFont" of "PBYTE" to "Verdana29x32_ItalicUnderLine".   Property index: 4
      $03010504, $00471908,   //set property:  "BaseProps.OnMouseUpUser" of "PBYTE" to "DynTFTButton0_OnMouseUpUser".   Property index: 5

      $01084203, $001D0009, $001E0050,   //create lbl1(3, 9, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0031206C,   //set property:  "Caption" of "STRING" to "Label 1".   Property index: 1
      $03080204, $00FA8282,   //set property:  "Color" of "TCOLOR" to "00FA8282".   Property index: 2

      $01084203, $001D0081, $001E0050,   //create lbl2(3, 129, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0032206C,   //set property:  "Caption" of "STRING" to "Label 2".   Property index: 1
      $03080204, $00FA8282,   //set property:  "Color" of "TCOLOR" to "00FA8282".   Property index: 2

      $01084203, $001D0109, $001E0050,   //create lbl3(3, 265, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0033206C,   //set property:  "Caption" of "STRING" to "Label 3".   Property index: 1
      $03080204, $00FA8282,   //set property:  "Color" of "TCOLOR" to "00FA8282".   Property index: 2

      $01084203, $001D0181, $001E0050,   //create lbl4(3, 385, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0034206C,   //set property:  "Caption" of "STRING" to "Label 4".   Property index: 1
      $03080204, $00FA8282,   //set property:  "Color" of "TCOLOR" to "00FA8282".   Property index: 2

      $010F4304, $00370001, $00B8013E,   //create vkTest(4, 1, 55, 318, 184)  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $030F0004, $00471308,   //set property:  "OnCharKey" of "PBYTE" to "VirtualKeyboard_OnCharKey".   Property index: 0
      $030F0104, $0047138C,   //set property:  "OnSpecialKey" of "PBYTE" to "VirtualKeyboard_OnSpecialKey".   Property index: 1

      $010D4304, $001B0009, $001800C8,   //create Edit1(4, 9, 27, 200, 24)  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $030D8005, $74696445, $00000031,   //set property:  "Text" of "STRING" to "Edit1".   Property index: 0

      $01104405, $001D0009, $001600A0,   //create ComboBox1(5, 9, 29, 160, 22)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03100004, $00FAFA6E,   //set property:  "ListBox^.Items^.BackgroundColor" of "TCOLOR" to "00FAFA6E".   Property index: 0
      $03108103, $00656E6F,   //set property:  "ListBox^.Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03108203, $006F7774,   //set property:  "ListBox^.Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03108305, $65726874, $00000065,   //set property:  "ListBox^.Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03108404, $72756F66,   //set property:  "ListBox^.Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03108504, $65766966,   //set property:  "ListBox^.Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03108603, $00786973,   //set property:  "ListBox^.Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03108705, $65766573, $0000006E,   //set property:  "ListBox^.Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03108805, $68676965, $00000074,   //set property:  "ListBox^.Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03108904, $656E696E,   //set property:  "ListBox^.Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03108A03, $006E6574,   //set property:  "ListBox^.Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03100B02, $0000000F,   //set property:  "ListBox^.Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03100C04, $00FAFA6E,   //set property:  "Edit^.Color" of "TCOLOR" to "00FAFA6E".   Property index: 12
      $03100D04, $00000000,   //set property:  "Editable" of "BOOLEAN" to "False".   Property index: 13
      $03100E04, $0000000A,   //set property:  "ListBox^.Items^.Count" of "INTEGER" to "10".   Property index: 14
      // Property ListBox^.Items^.TotalVisibleCount skipped because of compiler directives.
      // Property ListBox^.Items^.OnGetItem skipped because of compiler directives.

      $01104405, $004D0009, $001800A0,   //create ComboBox2(5, 9, 77, 160, 24)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03100004, $00FAFA6E,   //set property:  "ListBox^.Items^.BackgroundColor" of "TCOLOR" to "00FAFA6E".   Property index: 0
      $03108103, $00656E6F,   //set property:  "ListBox^.Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03108203, $006F7774,   //set property:  "ListBox^.Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03108305, $65726874, $00000065,   //set property:  "ListBox^.Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03108404, $72756F66,   //set property:  "ListBox^.Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03108504, $65766966,   //set property:  "ListBox^.Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03108603, $00786973,   //set property:  "ListBox^.Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03108705, $65766573, $0000006E,   //set property:  "ListBox^.Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03108805, $68676965, $00000074,   //set property:  "ListBox^.Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03108904, $656E696E,   //set property:  "ListBox^.Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03108A03, $006E6574,   //set property:  "ListBox^.Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03100B02, $0000000F,   //set property:  "ListBox^.Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03100E04, $0000000A,   //set property:  "ListBox^.Items^.Count" of "INTEGER" to "10".   Property index: 14
      // Property ListBox^.Items^.TotalVisibleCount skipped because of compiler directives.
      // Property ListBox^.Items^.OnGetItem skipped because of compiler directives.

      $01084405, $004D00C1, $00180050,   //create Label4(5, 193, 77, 80, 24)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088108, $74696445, $656C6261,   //set property:  "Caption" of "STRING" to "Editable".   Property index: 1
      $03080204, $00C8C800,   //set property:  "Color" of "TCOLOR" to "00C8C800".   Property index: 2
      $03080304, $00FFFFFF,   //set property:  "Font_Color" of "TCOLOR" to "00FFFFFF".   Property index: 3

      $01084405, $001D00C1, $00180082,   //create Label5(5, 193, 29, 130, 24)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $0308810F, $656C6553, $62617463, $6F20656C, $00796C6E,   //set property:  "Caption" of "STRING" to "Selectable only".   Property index: 1
      $03080204, $00C8C800,   //set property:  "Color" of "TCOLOR" to "00C8C800".   Property index: 2
      $03080304, $00FFFFFF,   //set property:  "Font_Color" of "TCOLOR" to "00FFFFFF".   Property index: 3

      $01074405, $00850009, $007800A0,   //create ListBox2(5, 9, 133, 160, 120)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03070004, $00F0F000,   //set property:  "Items^.BackgroundColor" of "TCOLOR" to "00F0F000".   Property index: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C04, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01074405, $008500F9, $007800A0,   //create ListBox4(5, 249, 133, 160, 120)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03070004, $00F0F000,   //set property:  "Items^.BackgroundColor" of "TCOLOR" to "00F0F000".   Property index: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C04, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01114506, $00210009, $001800C8,   //create TrackBar1(6, 9, 33, 200, 24)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03110004, $00000003,   //set property:  "Position" of "INTEGER" to "3".   Property index: 0
      $03110104, $004718C0,   //set property:  "OnTrackBarChange" of "PBYTE" to "TrackBar1_OnTrackBarChange".   Property index: 1

      $01114506, $005D0019, $00A00018,   //create TrackBar2(6, 25, 93, 24, 160)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03110004, $00000007,   //set property:  "Position" of "INTEGER" to "7".   Property index: 0
      $03110201, $00000001,   //set property:  "Orientation" of "BYTE" to "CTrackBarVertDir".   Property index: 2
      $03110104, $004718E4,   //set property:  "OnTrackBarChange" of "PBYTE" to "TrackBar2_OnTrackBarChange".   Property index: 1

      $01124506, $002D0101, $001400CC,   //create ProgressBar1(6, 257, 45, 204, 20)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03120004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03120104, $00000003,   //set property:  "Position" of "INTEGER" to "3".   Property index: 1

      $01124506, $005D0101, $00A00018,   //create ProgressBar2(6, 257, 93, 24, 160)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03120004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03120104, $00000007,   //set property:  "Position" of "INTEGER" to "7".   Property index: 1
      $03120201, $00000001,   //set property:  "Orientation" of "BYTE" to "CProgressBarVertDir".   Property index: 2

      $01014506, $00C80049, $00190068,   //create btnShowMessageBox(6, 73, 200, 104, 25)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0301800B, $7373654D, $20656761, $00786F42,   //set property:  "Caption" of "STRING" to "Message Box".   Property index: 0
      $03010504, $00471420,   //set property:  "BaseProps.OnMouseUpUser" of "PBYTE" to "btnShowMessageBox_OnMouseUpUser".   Property index: 5
      0  //stop execution
    );
  {$ENDIF} {$ENDIF} // IsDesktop DesktopApp_D2006

  {$IFDEF IsMCU} {$IFDEF PIC32App} // Profile: "PIC32App"   HandlersLocation: Lst file
    C_RTTI_CreateInstructionData: array[0..480] of DWord = (
      $04000005,   //Set build number to 5

      $01014001, $001D0009, $0028006E,   //create btn1(1, 9, 29, 110, 40)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03018008, $74747542, $31206E6F,   //set property:  "Caption" of "STRING" to "Button 1".   Property index: 0
      $03010104, $00000D6D,   //set property:  "Font_Color" of "TCOLOR" to "00000D6D".   Property index: 1

      $01014001, $001D0169, $0028006E,   //create btn2(1, 361, 29, 110, 40)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03018008, $74747542, $32206E6F,   //set property:  "Caption" of "STRING" to "Button 2".   Property index: 0
      $03010104, $00000D6D,   //set property:  "Font_Color" of "TCOLOR" to "00000D6D".   Property index: 1

      $01024001, $00220089, $001E001E,   //create Arrow1(1, 137, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00000D6D,   //set property:  "Color" of "TCOLOR" to "00000D6D".   Property index: 0
      $03020101, $00000002,   //set property:  "ArrowDir" of "BYTE" to "CLeftArrow".   Property index: 1

      $01024001, $002200B1, $001E001E,   //create Arrow2(1, 177, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00000D6D,   //set property:  "Color" of "TCOLOR" to "00000D6D".   Property index: 0
      $03020101, $00000003,   //set property:  "ArrowDir" of "BYTE" to "CRightArrow".   Property index: 1

      $01024001, $0022010F, $001E001E,   //create Arrow3(1, 271, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00000D6D,   //set property:  "Color" of "TCOLOR" to "00000D6D".   Property index: 0

      $01024001, $00220139, $001E001E,   //create Arrow4(1, 313, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00000D6D,   //set property:  "Color" of "TCOLOR" to "00000D6D".   Property index: 0
      $03020101, $00000001,   //set property:  "ArrowDir" of "BYTE" to "CDownArrow".   Property index: 1

      $01034001, $00550069, $00620112,   //create Panel1(1, 105, 85, 274, 98)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03030004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03038107, $656E6150, $0031206C,   //set property:  "Caption" of "STRING" to "Panel 1".   Property index: 1
      $03030204, $00006D6D,   //set property:  "Color" of "TCOLOR" to "00006D6D".   Property index: 2
      $03030304, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 3

      $01024001, $00A50011, $002D002D,   //create Arrow5(1, 17, 165, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00003734,   //set property:  "Color" of "TCOLOR" to "00003734".   Property index: 0

      $01024001, $00DD0011, $002D002D,   //create Arrow6(1, 17, 221, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00003734,   //set property:  "Color" of "TCOLOR" to "00003734".   Property index: 0
      $03020101, $00000001,   //set property:  "ArrowDir" of "BYTE" to "CDownArrow".   Property index: 1

      $01024001, $00A501A1, $002D002D,   //create Arrow7(1, 417, 165, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00003734,   //set property:  "Color" of "TCOLOR" to "00003734".   Property index: 0
      $03020101, $00000002,   //set property:  "ArrowDir" of "BYTE" to "CLeftArrow".   Property index: 1

      $01024001, $00DD01A1, $002D002D,   //create Arrow8(1, 417, 221, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00003734,   //set property:  "Color" of "TCOLOR" to "00003734".   Property index: 0
      $03020101, $00000003,   //set property:  "ArrowDir" of "BYTE" to "CRightArrow".   Property index: 1

      $01014001, $00BD00A9, $00230094,   //create btn3(1, 169, 189, 148, 35)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03010201, $00000000,   //set property:  "BaseProps.Enabled" of "BYTE" to "0".   Property index: 2
      $03010304, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 3
      $03018011, $61736944, $64656C62, $74754220, $206E6F74, $00000033,   //set property:  "Caption" of "STRING" to "Disabled Button 3".   Property index: 0

      $01014001, $00E500A9, $00230094,   //create btn4(1, 169, 229, 148, 35)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03010201, $00000000,   //set property:  "BaseProps.Enabled" of "BYTE" to "0".   Property index: 2
      $03010304, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 3
      $03018011, $61736944, $64656C62, $74754220, $206E6F74, $00000034,   //set property:  "Caption" of "STRING" to "Disabled Button 4".   Property index: 0

      $01024001, $001D00D8, $002D002D,   //create Arrow9(1, 216, 29, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $0000EF7F,   //set property:  "Color" of "TCOLOR" to "0000EF7F".   Property index: 0
      $03020101, $00000004,   //set property:  "ArrowDir" of "BYTE" to "CUndefinedArrow".   Property index: 1

      $01044102, $001D0019, $0019008C,   //create CheckBox1(2, 25, 29, 140, 25)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0304800A, $63656843, $786F426B, $00003120,   //set property:  "Caption" of "STRING" to "CheckBox 1".   Property index: 0
      $03040104, $00009417,   //set property:  "Color" of "TCOLOR" to "00009417".   Property index: 1
      $03040204, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 2

      $01044102, $00450019, $0019008C,   //create CheckBox2(2, 25, 69, 140, 25)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0304800A, $63656843, $786F426B, $00003220,   //set property:  "Caption" of "STRING" to "CheckBox 2".   Property index: 0
      $03040104, $00009417,   //set property:  "Color" of "TCOLOR" to "00009417".   Property index: 1
      $03040204, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 2

      $01044102, $001D00F9, $0019008C,   //create CheckBox3(2, 249, 29, 140, 25)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03040301, $00000000,   //set property:  "BaseProps.Enabled" of "BYTE" to "0".   Property index: 3
      $0304800A, $63656843, $786F426B, $00003320,   //set property:  "Caption" of "STRING" to "CheckBox 3".   Property index: 0
      $03040104, $00009417,   //set property:  "Color" of "TCOLOR" to "00009417".   Property index: 1
      $03040204, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 2

      $01054102, $00ED0019, $00140199,   //create ScrollBar1(2, 25, 237, 409, 20)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0

      $01054102, $001D01B9, $00D00014,   //create ScrollBar2(2, 441, 29, 20, 208)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03050001, $00000001,   //set property:  "Direction" of "BYTE" to "CScrollBarVertDir".   Property index: 0

      $01074102, $006D0019, $006F008C,   //create ListBox1(2, 25, 109, 140, 111)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03070004, $0000BD7F,   //set property:  "Items^.BackgroundColor" of "TCOLOR" to "0000BD7F".   Property index: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C02, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01074102, $006D00F9, $006F008C,   //create ListBox3(2, 249, 109, 140, 111)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C02, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01014102, $003F00F9, $0026008C,   //create DynTFTButton0(2, 249, 63, 140, 38)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03018004, $306E7462,   //set property:  "Caption" of "STRING" to "btn0".   Property index: 0
      $03010404, $9D01AD70,   //set property:  "ActiveFont" of "PBYTE" to "Verdana29x32_ItalicUnderLine".   Property index: 4
      $03010504, $9D018828,   //set property:  "BaseProps.OnMouseUpUser" of "PBYTE" to "DynTFTButton0_OnMouseUpUser".   Property index: 5

      $01084203, $001D0009, $001E0050,   //create lbl1(3, 9, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0031206C,   //set property:  "Caption" of "STRING" to "Label 1".   Property index: 1
      $03080204, $0000841F,   //set property:  "Color" of "TCOLOR" to "0000841F".   Property index: 2

      $01084203, $001D0081, $001E0050,   //create lbl2(3, 129, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0032206C,   //set property:  "Caption" of "STRING" to "Label 2".   Property index: 1
      $03080204, $0000841F,   //set property:  "Color" of "TCOLOR" to "0000841F".   Property index: 2

      $01084203, $001D0109, $001E0050,   //create lbl3(3, 265, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0033206C,   //set property:  "Caption" of "STRING" to "Label 3".   Property index: 1
      $03080204, $0000841F,   //set property:  "Color" of "TCOLOR" to "0000841F".   Property index: 2

      $01084203, $001D0181, $001E0050,   //create lbl4(3, 385, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0034206C,   //set property:  "Caption" of "STRING" to "Label 4".   Property index: 1
      $03080204, $0000841F,   //set property:  "Color" of "TCOLOR" to "0000841F".   Property index: 2

      $010F4304, $00370001, $00B8013E,   //create vkTest(4, 1, 55, 318, 184)  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $030F0004, $9D01778C,   //set property:  "OnCharKey" of "PBYTE" to "VirtualKeyboard_OnCharKey".   Property index: 0
      $030F0104, $9D017338,   //set property:  "OnSpecialKey" of "PBYTE" to "VirtualKeyboard_OnSpecialKey".   Property index: 1

      $010D4304, $001B0009, $001800C8,   //create Edit1(4, 9, 27, 200, 24)  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $030D8005, $74696445, $00000031,   //set property:  "Text" of "STRING" to "Edit1".   Property index: 0

      $01104405, $001D0009, $001600A0,   //create ComboBox1(5, 9, 29, 160, 22)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03100004, $00006FDF,   //set property:  "ListBox^.Items^.BackgroundColor" of "TCOLOR" to "00006FDF".   Property index: 0
      $03108103, $00656E6F,   //set property:  "ListBox^.Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03108203, $006F7774,   //set property:  "ListBox^.Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03108305, $65726874, $00000065,   //set property:  "ListBox^.Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03108404, $72756F66,   //set property:  "ListBox^.Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03108504, $65766966,   //set property:  "ListBox^.Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03108603, $00786973,   //set property:  "ListBox^.Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03108705, $65766573, $0000006E,   //set property:  "ListBox^.Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03108805, $68676965, $00000074,   //set property:  "ListBox^.Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03108904, $656E696E,   //set property:  "ListBox^.Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03108A03, $006E6574,   //set property:  "ListBox^.Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03100B02, $0000000F,   //set property:  "ListBox^.Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03100C04, $00006FDF,   //set property:  "Edit^.Color" of "TCOLOR" to "00006FDF".   Property index: 12
      $03100D04, $00000000,   //set property:  "Editable" of "BOOLEAN" to "False".   Property index: 13
      $03100E02, $0000000A,   //set property:  "ListBox^.Items^.Count" of "INTEGER" to "10".   Property index: 14
      // Property ListBox^.Items^.TotalVisibleCount skipped because of compiler directives.
      // Property ListBox^.Items^.OnGetItem skipped because of compiler directives.

      $01104405, $004D0009, $001800A0,   //create ComboBox2(5, 9, 77, 160, 24)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03100004, $00006FDF,   //set property:  "ListBox^.Items^.BackgroundColor" of "TCOLOR" to "00006FDF".   Property index: 0
      $03108103, $00656E6F,   //set property:  "ListBox^.Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03108203, $006F7774,   //set property:  "ListBox^.Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03108305, $65726874, $00000065,   //set property:  "ListBox^.Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03108404, $72756F66,   //set property:  "ListBox^.Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03108504, $65766966,   //set property:  "ListBox^.Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03108603, $00786973,   //set property:  "ListBox^.Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03108705, $65766573, $0000006E,   //set property:  "ListBox^.Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03108805, $68676965, $00000074,   //set property:  "ListBox^.Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03108904, $656E696E,   //set property:  "ListBox^.Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03108A03, $006E6574,   //set property:  "ListBox^.Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03100B02, $0000000F,   //set property:  "ListBox^.Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03100E02, $0000000A,   //set property:  "ListBox^.Items^.Count" of "INTEGER" to "10".   Property index: 14
      // Property ListBox^.Items^.TotalVisibleCount skipped because of compiler directives.
      // Property ListBox^.Items^.OnGetItem skipped because of compiler directives.

      $01084405, $004D00C1, $00180050,   //create Label4(5, 193, 77, 80, 24)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088108, $74696445, $656C6261,   //set property:  "Caption" of "STRING" to "Editable".   Property index: 1
      $03080204, $00000659,   //set property:  "Color" of "TCOLOR" to "00000659".   Property index: 2
      $03080304, $0000FFFF,   //set property:  "Font_Color" of "TCOLOR" to "0000FFFF".   Property index: 3

      $01084405, $001D00C1, $00180082,   //create Label5(5, 193, 29, 130, 24)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $0308810F, $656C6553, $62617463, $6F20656C, $00796C6E,   //set property:  "Caption" of "STRING" to "Selectable only".   Property index: 1
      $03080204, $00000659,   //set property:  "Color" of "TCOLOR" to "00000659".   Property index: 2
      $03080304, $0000FFFF,   //set property:  "Font_Color" of "TCOLOR" to "0000FFFF".   Property index: 3

      $01074405, $00850009, $007800A0,   //create ListBox2(5, 9, 133, 160, 120)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03070004, $0000079E,   //set property:  "Items^.BackgroundColor" of "TCOLOR" to "0000079E".   Property index: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C02, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01074405, $008500F9, $007800A0,   //create ListBox4(5, 249, 133, 160, 120)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03070004, $0000079E,   //set property:  "Items^.BackgroundColor" of "TCOLOR" to "0000079E".   Property index: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C02, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01114506, $00210009, $001800C8,   //create TrackBar1(6, 9, 33, 200, 24)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03110002, $00000003,   //set property:  "Position" of "INTEGER" to "3".   Property index: 0
      $03110104, $9D0167FC,   //set property:  "OnTrackBarChange" of "PBYTE" to "TrackBar1_OnTrackBarChange".   Property index: 1

      $01114506, $005D0019, $00A00018,   //create TrackBar2(6, 25, 93, 24, 160)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03110002, $00000007,   //set property:  "Position" of "INTEGER" to "7".   Property index: 0
      $03110201, $00000001,   //set property:  "Orientation" of "BYTE" to "CTrackBarVertDir".   Property index: 2
      $03110104, $9D016AD8,   //set property:  "OnTrackBarChange" of "PBYTE" to "TrackBar2_OnTrackBarChange".   Property index: 1

      $01124506, $002D0101, $001400CC,   //create ProgressBar1(6, 257, 45, 204, 20)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03120004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03120102, $00000003,   //set property:  "Position" of "INTEGER" to "3".   Property index: 1

      $01124506, $005D0101, $00A00018,   //create ProgressBar2(6, 257, 93, 24, 160)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03120004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03120102, $00000007,   //set property:  "Position" of "INTEGER" to "7".   Property index: 1
      $03120201, $00000001,   //set property:  "Orientation" of "BYTE" to "CProgressBarVertDir".   Property index: 2

      $01014506, $00C80049, $00190068,   //create btnShowMessageBox(6, 73, 200, 104, 25)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0301800B, $7373654D, $20656761, $00786F42,   //set property:  "Caption" of "STRING" to "Message Box".   Property index: 0
      $03010504, $9D01684C,   //set property:  "BaseProps.OnMouseUpUser" of "PBYTE" to "btnShowMessageBox_OnMouseUpUser".   Property index: 5
      0  //stop execution
    );
  {$ENDIF} {$ENDIF} // IsMCU PIC32App

  {$IFDEF IsDesktop} {$IFDEF DesktopApp_D10_2} // Profile: "DesktopApp_D10_2"   HandlersLocation: Lst file
    C_RTTI_CreateInstructionData: array[0..480] of DWord = (
      $04000003,   //Set build number to 3

      $01014001, $001D0009, $0028006E,   //create btn1(1, 9, 29, 110, 40)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03018008, $74747542, $31206E6F,   //set property:  "Caption" of "STRING" to "Button 1".   Property index: 0
      $03010104, $006FAD0B,   //set property:  "Font_Color" of "TCOLOR" to "006FAD0B".   Property index: 1

      $01014001, $001D0169, $0028006E,   //create btn2(1, 361, 29, 110, 40)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03018008, $74747542, $32206E6F,   //set property:  "Caption" of "STRING" to "Button 2".   Property index: 0
      $03010104, $006FAD0B,   //set property:  "Font_Color" of "TCOLOR" to "006FAD0B".   Property index: 1

      $01024001, $00220089, $001E001E,   //create Arrow1(1, 137, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $006FAD0B,   //set property:  "Color" of "TCOLOR" to "006FAD0B".   Property index: 0
      $03020101, $00000002,   //set property:  "ArrowDir" of "BYTE" to "CLeftArrow".   Property index: 1

      $01024001, $002200B1, $001E001E,   //create Arrow2(1, 177, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $006FAD0B,   //set property:  "Color" of "TCOLOR" to "006FAD0B".   Property index: 0
      $03020101, $00000003,   //set property:  "ArrowDir" of "BYTE" to "CRightArrow".   Property index: 1

      $01024001, $0022010F, $001E001E,   //create Arrow3(1, 271, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $006FAD0B,   //set property:  "Color" of "TCOLOR" to "006FAD0B".   Property index: 0

      $01024001, $00220139, $001E001E,   //create Arrow4(1, 313, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $006FAD0B,   //set property:  "Color" of "TCOLOR" to "006FAD0B".   Property index: 0
      $03020101, $00000001,   //set property:  "ArrowDir" of "BYTE" to "CDownArrow".   Property index: 1

      $01034001, $00550069, $00620112,   //create Panel1(1, 105, 85, 274, 98)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03030004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03038107, $656E6150, $0031206C,   //set property:  "Caption" of "STRING" to "Panel 1".   Property index: 1
      $03030204, $006FAD6F,   //set property:  "Color" of "TCOLOR" to "006FAD6F".   Property index: 2
      $03030304, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 3

      $01024001, $00A50011, $002D002D,   //create Arrow5(1, 17, 165, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00A0E632,   //set property:  "Color" of "TCOLOR" to "00A0E632".   Property index: 0

      $01024001, $00DD0011, $002D002D,   //create Arrow6(1, 17, 221, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00A0E632,   //set property:  "Color" of "TCOLOR" to "00A0E632".   Property index: 0
      $03020101, $00000001,   //set property:  "ArrowDir" of "BYTE" to "CDownArrow".   Property index: 1

      $01024001, $00A501A1, $002D002D,   //create Arrow7(1, 417, 165, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00A0E632,   //set property:  "Color" of "TCOLOR" to "00A0E632".   Property index: 0
      $03020101, $00000002,   //set property:  "ArrowDir" of "BYTE" to "CLeftArrow".   Property index: 1

      $01024001, $00DD01A1, $002D002D,   //create Arrow8(1, 417, 221, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00A0E632,   //set property:  "Color" of "TCOLOR" to "00A0E632".   Property index: 0
      $03020101, $00000003,   //set property:  "ArrowDir" of "BYTE" to "CRightArrow".   Property index: 1

      $01014001, $00BD00A9, $00230094,   //create btn3(1, 169, 189, 148, 35)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03010201, $00000000,   //set property:  "BaseProps.Enabled" of "BYTE" to "0".   Property index: 2
      $03010304, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 3
      $03018011, $61736944, $64656C62, $74754220, $206E6F74, $00000033,   //set property:  "Caption" of "STRING" to "Disabled Button 3".   Property index: 0

      $01014001, $00E500A9, $00230094,   //create btn4(1, 169, 229, 148, 35)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03010201, $00000000,   //set property:  "BaseProps.Enabled" of "BYTE" to "0".   Property index: 2
      $03010304, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 3
      $03018011, $61736944, $64656C62, $74754220, $206E6F74, $00000034,   //set property:  "Caption" of "STRING" to "Disabled Button 4".   Property index: 0

      $01024001, $001D00D8, $002D002D,   //create Arrow9(1, 216, 29, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00FFEFEF,   //set property:  "Color" of "TCOLOR" to "00FFEFEF".   Property index: 0
      $03020101, $00000004,   //set property:  "ArrowDir" of "BYTE" to "CUndefinedArrow".   Property index: 1

      $01044102, $001D0019, $0019008C,   //create CheckBox1(2, 25, 29, 140, 25)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0304800A, $63656843, $786F426B, $00003120,   //set property:  "Caption" of "STRING" to "CheckBox 1".   Property index: 0
      $03040104, $00BE8296,   //set property:  "Color" of "TCOLOR" to "00BE8296".   Property index: 1
      $03040204, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 2

      $01044102, $00450019, $0019008C,   //create CheckBox2(2, 25, 69, 140, 25)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0304800A, $63656843, $786F426B, $00003220,   //set property:  "Caption" of "STRING" to "CheckBox 2".   Property index: 0
      $03040104, $00BE8296,   //set property:  "Color" of "TCOLOR" to "00BE8296".   Property index: 1
      $03040204, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 2

      $01044102, $001D00F9, $0019008C,   //create CheckBox3(2, 249, 29, 140, 25)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03040301, $00000000,   //set property:  "BaseProps.Enabled" of "BYTE" to "0".   Property index: 3
      $0304800A, $63656843, $786F426B, $00003320,   //set property:  "Caption" of "STRING" to "CheckBox 3".   Property index: 0
      $03040104, $00BE8296,   //set property:  "Color" of "TCOLOR" to "00BE8296".   Property index: 1
      $03040204, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 2

      $01054102, $00ED0019, $00140199,   //create ScrollBar1(2, 25, 237, 409, 20)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0

      $01054102, $001D01B9, $00D00014,   //create ScrollBar2(2, 441, 29, 20, 208)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03050001, $00000001,   //set property:  "Direction" of "BYTE" to "CScrollBarVertDir".   Property index: 0

      $01074102, $006D0019, $006F008C,   //create ListBox1(2, 25, 109, 140, 111)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03070004, $00FAAFBE,   //set property:  "Items^.BackgroundColor" of "TCOLOR" to "00FAAFBE".   Property index: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C04, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01074102, $006D00F9, $006F008C,   //create ListBox3(2, 249, 109, 140, 111)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C04, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01014102, $003F00F9, $0026008C,   //create DynTFTButton0(2, 249, 63, 140, 38)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03018004, $306E7462,   //set property:  "Caption" of "STRING" to "btn0".   Property index: 0
      $03010404, $00475914,   //set property:  "ActiveFont" of "PBYTE" to "Verdana29x32_ItalicUnderLine".   Property index: 4
      $03010504, $0046FB14,   //set property:  "BaseProps.OnMouseUpUser" of "PBYTE" to "DynTFTButton0_OnMouseUpUser".   Property index: 5

      $01084203, $001D0009, $001E0050,   //create lbl1(3, 9, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0031206C,   //set property:  "Caption" of "STRING" to "Label 1".   Property index: 1
      $03080204, $00FA8282,   //set property:  "Color" of "TCOLOR" to "00FA8282".   Property index: 2

      $01084203, $001D0081, $001E0050,   //create lbl2(3, 129, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0032206C,   //set property:  "Caption" of "STRING" to "Label 2".   Property index: 1
      $03080204, $00FA8282,   //set property:  "Color" of "TCOLOR" to "00FA8282".   Property index: 2

      $01084203, $001D0109, $001E0050,   //create lbl3(3, 265, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0033206C,   //set property:  "Caption" of "STRING" to "Label 3".   Property index: 1
      $03080204, $00FA8282,   //set property:  "Color" of "TCOLOR" to "00FA8282".   Property index: 2

      $01084203, $001D0181, $001E0050,   //create lbl4(3, 385, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0034206C,   //set property:  "Caption" of "STRING" to "Label 4".   Property index: 1
      $03080204, $00FA8282,   //set property:  "Color" of "TCOLOR" to "00FA8282".   Property index: 2

      $010F4304, $00370001, $00B8013E,   //create vkTest(4, 1, 55, 318, 184)  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $030F0004, $0046F570,   //set property:  "OnCharKey" of "PBYTE" to "VirtualKeyboard_OnCharKey".   Property index: 0
      $030F0104, $0046F5F4,   //set property:  "OnSpecialKey" of "PBYTE" to "VirtualKeyboard_OnSpecialKey".   Property index: 1

      $010D4304, $001B0009, $001800C8,   //create Edit1(4, 9, 27, 200, 24)  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $030D8005, $74696445, $00000031,   //set property:  "Text" of "STRING" to "Edit1".   Property index: 0

      $01104405, $001D0009, $001600A0,   //create ComboBox1(5, 9, 29, 160, 22)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03100004, $00FAFA6E,   //set property:  "ListBox^.Items^.BackgroundColor" of "TCOLOR" to "00FAFA6E".   Property index: 0
      $03108103, $00656E6F,   //set property:  "ListBox^.Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03108203, $006F7774,   //set property:  "ListBox^.Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03108305, $65726874, $00000065,   //set property:  "ListBox^.Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03108404, $72756F66,   //set property:  "ListBox^.Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03108504, $65766966,   //set property:  "ListBox^.Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03108603, $00786973,   //set property:  "ListBox^.Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03108705, $65766573, $0000006E,   //set property:  "ListBox^.Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03108805, $68676965, $00000074,   //set property:  "ListBox^.Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03108904, $656E696E,   //set property:  "ListBox^.Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03108A03, $006E6574,   //set property:  "ListBox^.Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03100B02, $0000000F,   //set property:  "ListBox^.Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03100C04, $00FAFA6E,   //set property:  "Edit^.Color" of "TCOLOR" to "00FAFA6E".   Property index: 12
      $03100D04, $00000000,   //set property:  "Editable" of "BOOLEAN" to "False".   Property index: 13
      $03100E04, $0000000A,   //set property:  "ListBox^.Items^.Count" of "INTEGER" to "10".   Property index: 14
      // Property ListBox^.Items^.TotalVisibleCount skipped because of compiler directives.
      // Property ListBox^.Items^.OnGetItem skipped because of compiler directives.

      $01104405, $004D0009, $001800A0,   //create ComboBox2(5, 9, 77, 160, 24)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03100004, $00FAFA6E,   //set property:  "ListBox^.Items^.BackgroundColor" of "TCOLOR" to "00FAFA6E".   Property index: 0
      $03108103, $00656E6F,   //set property:  "ListBox^.Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03108203, $006F7774,   //set property:  "ListBox^.Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03108305, $65726874, $00000065,   //set property:  "ListBox^.Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03108404, $72756F66,   //set property:  "ListBox^.Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03108504, $65766966,   //set property:  "ListBox^.Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03108603, $00786973,   //set property:  "ListBox^.Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03108705, $65766573, $0000006E,   //set property:  "ListBox^.Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03108805, $68676965, $00000074,   //set property:  "ListBox^.Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03108904, $656E696E,   //set property:  "ListBox^.Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03108A03, $006E6574,   //set property:  "ListBox^.Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03100B02, $0000000F,   //set property:  "ListBox^.Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03100E04, $0000000A,   //set property:  "ListBox^.Items^.Count" of "INTEGER" to "10".   Property index: 14
      // Property ListBox^.Items^.TotalVisibleCount skipped because of compiler directives.
      // Property ListBox^.Items^.OnGetItem skipped because of compiler directives.

      $01084405, $004D00C1, $00180050,   //create Label4(5, 193, 77, 80, 24)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088108, $74696445, $656C6261,   //set property:  "Caption" of "STRING" to "Editable".   Property index: 1
      $03080204, $00C8C800,   //set property:  "Color" of "TCOLOR" to "00C8C800".   Property index: 2
      $03080304, $00FFFFFF,   //set property:  "Font_Color" of "TCOLOR" to "00FFFFFF".   Property index: 3

      $01084405, $001D00C1, $00180082,   //create Label5(5, 193, 29, 130, 24)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $0308810F, $656C6553, $62617463, $6F20656C, $00796C6E,   //set property:  "Caption" of "STRING" to "Selectable only".   Property index: 1
      $03080204, $00C8C800,   //set property:  "Color" of "TCOLOR" to "00C8C800".   Property index: 2
      $03080304, $00FFFFFF,   //set property:  "Font_Color" of "TCOLOR" to "00FFFFFF".   Property index: 3

      $01074405, $00850009, $007800A0,   //create ListBox2(5, 9, 133, 160, 120)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03070004, $00F0F000,   //set property:  "Items^.BackgroundColor" of "TCOLOR" to "00F0F000".   Property index: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C04, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01074405, $008500F9, $007800A0,   //create ListBox4(5, 249, 133, 160, 120)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03070004, $00F0F000,   //set property:  "Items^.BackgroundColor" of "TCOLOR" to "00F0F000".   Property index: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C04, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01114506, $00210009, $001800C8,   //create TrackBar1(6, 9, 33, 200, 24)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03110004, $00000003,   //set property:  "Position" of "INTEGER" to "3".   Property index: 0
      $03110104, $0046FACC,   //set property:  "OnTrackBarChange" of "PBYTE" to "TrackBar1_OnTrackBarChange".   Property index: 1

      $01114506, $005D0019, $00A00018,   //create TrackBar2(6, 25, 93, 24, 160)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03110004, $00000007,   //set property:  "Position" of "INTEGER" to "7".   Property index: 0
      $03110201, $00000001,   //set property:  "Orientation" of "BYTE" to "CTrackBarVertDir".   Property index: 2
      $03110104, $0046FAF0,   //set property:  "OnTrackBarChange" of "PBYTE" to "TrackBar2_OnTrackBarChange".   Property index: 1

      $01124506, $002D0101, $001400CC,   //create ProgressBar1(6, 257, 45, 204, 20)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03120004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03120104, $00000003,   //set property:  "Position" of "INTEGER" to "3".   Property index: 1

      $01124506, $005D0101, $00A00018,   //create ProgressBar2(6, 257, 93, 24, 160)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03120004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03120104, $00000007,   //set property:  "Position" of "INTEGER" to "7".   Property index: 1
      $03120201, $00000001,   //set property:  "Orientation" of "BYTE" to "CProgressBarVertDir".   Property index: 2

      $01014506, $00C80049, $00190068,   //create btnShowMessageBox(6, 73, 200, 104, 25)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0301800B, $7373654D, $20656761, $00786F42,   //set property:  "Caption" of "STRING" to "Message Box".   Property index: 0
      $03010504, $0046F688,   //set property:  "BaseProps.OnMouseUpUser" of "PBYTE" to "btnShowMessageBox_OnMouseUpUser".   Property index: 5
      0  //stop execution
    );
  {$ENDIF} {$ENDIF} // IsDesktop DesktopApp_D10_2

  {$IFDEF IsDesktop} {$IFDEF DesktopApp_FP} // Profile: "DesktopApp_FP"   HandlersLocation: Lst file
    C_RTTI_CreateInstructionData: array[0..480] of DWord = (
      $04000004,   //Set build number to 4

      $01014001, $001D0009, $0028006E,   //create btn1(1, 9, 29, 110, 40)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03018008, $74747542, $31206E6F,   //set property:  "Caption" of "STRING" to "Button 1".   Property index: 0
      $03010104, $006FAD0B,   //set property:  "Font_Color" of "TCOLOR" to "006FAD0B".   Property index: 1

      $01014001, $001D0169, $0028006E,   //create btn2(1, 361, 29, 110, 40)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03018008, $74747542, $32206E6F,   //set property:  "Caption" of "STRING" to "Button 2".   Property index: 0
      $03010104, $006FAD0B,   //set property:  "Font_Color" of "TCOLOR" to "006FAD0B".   Property index: 1

      $01024001, $00220089, $001E001E,   //create Arrow1(1, 137, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $006FAD0B,   //set property:  "Color" of "TCOLOR" to "006FAD0B".   Property index: 0
      $03020101, $00000002,   //set property:  "ArrowDir" of "BYTE" to "CLeftArrow".   Property index: 1

      $01024001, $002200B1, $001E001E,   //create Arrow2(1, 177, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $006FAD0B,   //set property:  "Color" of "TCOLOR" to "006FAD0B".   Property index: 0
      $03020101, $00000003,   //set property:  "ArrowDir" of "BYTE" to "CRightArrow".   Property index: 1

      $01024001, $0022010F, $001E001E,   //create Arrow3(1, 271, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $006FAD0B,   //set property:  "Color" of "TCOLOR" to "006FAD0B".   Property index: 0

      $01024001, $00220139, $001E001E,   //create Arrow4(1, 313, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $006FAD0B,   //set property:  "Color" of "TCOLOR" to "006FAD0B".   Property index: 0
      $03020101, $00000001,   //set property:  "ArrowDir" of "BYTE" to "CDownArrow".   Property index: 1

      $01034001, $00550069, $00620112,   //create Panel1(1, 105, 85, 274, 98)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03030004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03038107, $656E6150, $0031206C,   //set property:  "Caption" of "STRING" to "Panel 1".   Property index: 1
      $03030204, $006FAD6F,   //set property:  "Color" of "TCOLOR" to "006FAD6F".   Property index: 2
      $03030304, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 3

      $01024001, $00A50011, $002D002D,   //create Arrow5(1, 17, 165, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00A0E632,   //set property:  "Color" of "TCOLOR" to "00A0E632".   Property index: 0

      $01024001, $00DD0011, $002D002D,   //create Arrow6(1, 17, 221, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00A0E632,   //set property:  "Color" of "TCOLOR" to "00A0E632".   Property index: 0
      $03020101, $00000001,   //set property:  "ArrowDir" of "BYTE" to "CDownArrow".   Property index: 1

      $01024001, $00A501A1, $002D002D,   //create Arrow7(1, 417, 165, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00A0E632,   //set property:  "Color" of "TCOLOR" to "00A0E632".   Property index: 0
      $03020101, $00000002,   //set property:  "ArrowDir" of "BYTE" to "CLeftArrow".   Property index: 1

      $01024001, $00DD01A1, $002D002D,   //create Arrow8(1, 417, 221, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00A0E632,   //set property:  "Color" of "TCOLOR" to "00A0E632".   Property index: 0
      $03020101, $00000003,   //set property:  "ArrowDir" of "BYTE" to "CRightArrow".   Property index: 1

      $01014001, $00BD00A9, $00230094,   //create btn3(1, 169, 189, 148, 35)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03010201, $00000000,   //set property:  "BaseProps.Enabled" of "BYTE" to "0".   Property index: 2
      $03010304, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 3
      $03018011, $61736944, $64656C62, $74754220, $206E6F74, $00000033,   //set property:  "Caption" of "STRING" to "Disabled Button 3".   Property index: 0

      $01014001, $00E500A9, $00230094,   //create btn4(1, 169, 229, 148, 35)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03010201, $00000000,   //set property:  "BaseProps.Enabled" of "BYTE" to "0".   Property index: 2
      $03010304, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 3
      $03018011, $61736944, $64656C62, $74754220, $206E6F74, $00000034,   //set property:  "Caption" of "STRING" to "Disabled Button 4".   Property index: 0

      $01024001, $001D00D8, $002D002D,   //create Arrow9(1, 216, 29, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00FFEFEF,   //set property:  "Color" of "TCOLOR" to "00FFEFEF".   Property index: 0
      $03020101, $00000004,   //set property:  "ArrowDir" of "BYTE" to "CUndefinedArrow".   Property index: 1

      $01044102, $001D0019, $0019008C,   //create CheckBox1(2, 25, 29, 140, 25)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0304800A, $63656843, $786F426B, $00003120,   //set property:  "Caption" of "STRING" to "CheckBox 1".   Property index: 0
      $03040104, $00BE8296,   //set property:  "Color" of "TCOLOR" to "00BE8296".   Property index: 1
      $03040204, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 2

      $01044102, $00450019, $0019008C,   //create CheckBox2(2, 25, 69, 140, 25)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0304800A, $63656843, $786F426B, $00003220,   //set property:  "Caption" of "STRING" to "CheckBox 2".   Property index: 0
      $03040104, $00BE8296,   //set property:  "Color" of "TCOLOR" to "00BE8296".   Property index: 1
      $03040204, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 2

      $01044102, $001D00F9, $0019008C,   //create CheckBox3(2, 249, 29, 140, 25)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03040301, $00000000,   //set property:  "BaseProps.Enabled" of "BYTE" to "0".   Property index: 3
      $0304800A, $63656843, $786F426B, $00003320,   //set property:  "Caption" of "STRING" to "CheckBox 3".   Property index: 0
      $03040104, $00BE8296,   //set property:  "Color" of "TCOLOR" to "00BE8296".   Property index: 1
      $03040204, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 2

      $01054102, $00ED0019, $00140199,   //create ScrollBar1(2, 25, 237, 409, 20)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0

      $01054102, $001D01B9, $00D00014,   //create ScrollBar2(2, 441, 29, 20, 208)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03050001, $00000001,   //set property:  "Direction" of "BYTE" to "CScrollBarVertDir".   Property index: 0

      $01074102, $006D0019, $006F008C,   //create ListBox1(2, 25, 109, 140, 111)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03070004, $00FAAFBE,   //set property:  "Items^.BackgroundColor" of "TCOLOR" to "00FAAFBE".   Property index: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C04, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01074102, $006D00F9, $006F008C,   //create ListBox3(2, 249, 109, 140, 111)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C04, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01014102, $003F00F9, $0026008C,   //create DynTFTButton0(2, 249, 63, 140, 38)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03018004, $306E7462,   //set property:  "Caption" of "STRING" to "btn0".   Property index: 0
      $03010404, $0058F2B8,   //set property:  "ActiveFont" of "PBYTE" to "Verdana29x32_ItalicUnderLine".   Property index: 4
      $03010504, $00569340,   //set property:  "BaseProps.OnMouseUpUser" of "PBYTE" to "DynTFTButton0_OnMouseUpUser".   Property index: 5

      $01084203, $001D0009, $001E0050,   //create lbl1(3, 9, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0031206C,   //set property:  "Caption" of "STRING" to "Label 1".   Property index: 1
      $03080204, $00FA8282,   //set property:  "Color" of "TCOLOR" to "00FA8282".   Property index: 2

      $01084203, $001D0081, $001E0050,   //create lbl2(3, 129, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0032206C,   //set property:  "Caption" of "STRING" to "Label 2".   Property index: 1
      $03080204, $00FA8282,   //set property:  "Color" of "TCOLOR" to "00FA8282".   Property index: 2

      $01084203, $001D0109, $001E0050,   //create lbl3(3, 265, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0033206C,   //set property:  "Caption" of "STRING" to "Label 3".   Property index: 1
      $03080204, $00FA8282,   //set property:  "Color" of "TCOLOR" to "00FA8282".   Property index: 2

      $01084203, $001D0181, $001E0050,   //create lbl4(3, 385, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0034206C,   //set property:  "Caption" of "STRING" to "Label 4".   Property index: 1
      $03080204, $00FA8282,   //set property:  "Color" of "TCOLOR" to "00FA8282".   Property index: 2

      $010F4304, $00370001, $00B8013E,   //create vkTest(4, 1, 55, 318, 184)  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $030F0004, $00568C30,   //set property:  "OnCharKey" of "PBYTE" to "VirtualKeyboard_OnCharKey".   Property index: 0
      $030F0104, $00568CE0,   //set property:  "OnSpecialKey" of "PBYTE" to "VirtualKeyboard_OnSpecialKey".   Property index: 1

      $010D4304, $001B0009, $001800C8,   //create Edit1(4, 9, 27, 200, 24)  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $030D8005, $74696445, $00000031,   //set property:  "Text" of "STRING" to "Edit1".   Property index: 0

      $01104405, $001D0009, $001600A0,   //create ComboBox1(5, 9, 29, 160, 22)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03100004, $00FAFA6E,   //set property:  "ListBox^.Items^.BackgroundColor" of "TCOLOR" to "00FAFA6E".   Property index: 0
      $03108103, $00656E6F,   //set property:  "ListBox^.Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03108203, $006F7774,   //set property:  "ListBox^.Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03108305, $65726874, $00000065,   //set property:  "ListBox^.Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03108404, $72756F66,   //set property:  "ListBox^.Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03108504, $65766966,   //set property:  "ListBox^.Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03108603, $00786973,   //set property:  "ListBox^.Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03108705, $65766573, $0000006E,   //set property:  "ListBox^.Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03108805, $68676965, $00000074,   //set property:  "ListBox^.Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03108904, $656E696E,   //set property:  "ListBox^.Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03108A03, $006E6574,   //set property:  "ListBox^.Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03100B02, $0000000F,   //set property:  "ListBox^.Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03100C04, $00FAFA6E,   //set property:  "Edit^.Color" of "TCOLOR" to "00FAFA6E".   Property index: 12
      $03100D04, $00000000,   //set property:  "Editable" of "BOOLEAN" to "False".   Property index: 13
      $03100E04, $0000000A,   //set property:  "ListBox^.Items^.Count" of "INTEGER" to "10".   Property index: 14
      // Property ListBox^.Items^.TotalVisibleCount skipped because of compiler directives.
      // Property ListBox^.Items^.OnGetItem skipped because of compiler directives.

      $01104405, $004D0009, $001800A0,   //create ComboBox2(5, 9, 77, 160, 24)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03100004, $00FAFA6E,   //set property:  "ListBox^.Items^.BackgroundColor" of "TCOLOR" to "00FAFA6E".   Property index: 0
      $03108103, $00656E6F,   //set property:  "ListBox^.Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03108203, $006F7774,   //set property:  "ListBox^.Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03108305, $65726874, $00000065,   //set property:  "ListBox^.Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03108404, $72756F66,   //set property:  "ListBox^.Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03108504, $65766966,   //set property:  "ListBox^.Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03108603, $00786973,   //set property:  "ListBox^.Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03108705, $65766573, $0000006E,   //set property:  "ListBox^.Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03108805, $68676965, $00000074,   //set property:  "ListBox^.Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03108904, $656E696E,   //set property:  "ListBox^.Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03108A03, $006E6574,   //set property:  "ListBox^.Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03100B02, $0000000F,   //set property:  "ListBox^.Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03100E04, $0000000A,   //set property:  "ListBox^.Items^.Count" of "INTEGER" to "10".   Property index: 14
      // Property ListBox^.Items^.TotalVisibleCount skipped because of compiler directives.
      // Property ListBox^.Items^.OnGetItem skipped because of compiler directives.

      $01084405, $004D00C1, $00180050,   //create Label4(5, 193, 77, 80, 24)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088108, $74696445, $656C6261,   //set property:  "Caption" of "STRING" to "Editable".   Property index: 1
      $03080204, $00C8C800,   //set property:  "Color" of "TCOLOR" to "00C8C800".   Property index: 2
      $03080304, $00FFFFFF,   //set property:  "Font_Color" of "TCOLOR" to "00FFFFFF".   Property index: 3

      $01084405, $001D00C1, $00180082,   //create Label5(5, 193, 29, 130, 24)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $0308810F, $656C6553, $62617463, $6F20656C, $00796C6E,   //set property:  "Caption" of "STRING" to "Selectable only".   Property index: 1
      $03080204, $00C8C800,   //set property:  "Color" of "TCOLOR" to "00C8C800".   Property index: 2
      $03080304, $00FFFFFF,   //set property:  "Font_Color" of "TCOLOR" to "00FFFFFF".   Property index: 3

      $01074405, $00850009, $007800A0,   //create ListBox2(5, 9, 133, 160, 120)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03070004, $00F0F000,   //set property:  "Items^.BackgroundColor" of "TCOLOR" to "00F0F000".   Property index: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C04, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01074405, $008500F9, $007800A0,   //create ListBox4(5, 249, 133, 160, 120)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03070004, $00F0F000,   //set property:  "Items^.BackgroundColor" of "TCOLOR" to "00F0F000".   Property index: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C04, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01114506, $00210009, $001800C8,   //create TrackBar1(6, 9, 33, 200, 24)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03110004, $00000003,   //set property:  "Position" of "INTEGER" to "3".   Property index: 0
      $03110104, $005692E0,   //set property:  "OnTrackBarChange" of "PBYTE" to "TrackBar1_OnTrackBarChange".   Property index: 1

      $01114506, $005D0019, $00A00018,   //create TrackBar2(6, 25, 93, 24, 160)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03110004, $00000007,   //set property:  "Position" of "INTEGER" to "7".   Property index: 0
      $03110201, $00000001,   //set property:  "Orientation" of "BYTE" to "CTrackBarVertDir".   Property index: 2
      $03110104, $00569310,   //set property:  "OnTrackBarChange" of "PBYTE" to "TrackBar2_OnTrackBarChange".   Property index: 1

      $01124506, $002D0101, $001400CC,   //create ProgressBar1(6, 257, 45, 204, 20)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03120004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03120104, $00000003,   //set property:  "Position" of "INTEGER" to "3".   Property index: 1

      $01124506, $005D0101, $00A00018,   //create ProgressBar2(6, 257, 93, 24, 160)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03120004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03120104, $00000007,   //set property:  "Position" of "INTEGER" to "7".   Property index: 1
      $03120201, $00000001,   //set property:  "Orientation" of "BYTE" to "CProgressBarVertDir".   Property index: 2

      $01014506, $00C80049, $00190068,   //create btnShowMessageBox(6, 73, 200, 104, 25)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0301800B, $7373654D, $20656761, $00786F42,   //set property:  "Caption" of "STRING" to "Message Box".   Property index: 0
      $03010504, $00568DB0,   //set property:  "BaseProps.OnMouseUpUser" of "PBYTE" to "btnShowMessageBox_OnMouseUpUser".   Property index: 5
      0  //stop execution
    );
  {$ENDIF} {$ENDIF} // IsDesktop DesktopApp_FP

  {$IFDEF IsMCU} {$IFDEF PIC32AppAddrArr} // Profile: "PIC32AppAddrArr"   HandlersLocation: Code (constant array of addresses)
    C_RTTI_CreateInstructionData: array[0..480] of DWord = (
      $04000020,   //Set build number to 32

      $01014001, $001D0009, $0028006E,   //create btn1(1, 9, 29, 110, 40)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03018008, $74747542, $31206E6F,   //set property:  "Caption" of "STRING" to "Button 1".   Property index: 0
      $03010104, $00000D6D,   //set property:  "Font_Color" of "TCOLOR" to "00000D6D".   Property index: 1

      $01014001, $001D0169, $0028006E,   //create btn2(1, 361, 29, 110, 40)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03018008, $74747542, $32206E6F,   //set property:  "Caption" of "STRING" to "Button 2".   Property index: 0
      $03010104, $00000D6D,   //set property:  "Font_Color" of "TCOLOR" to "00000D6D".   Property index: 1

      $01024001, $00220089, $001E001E,   //create Arrow1(1, 137, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00000D6D,   //set property:  "Color" of "TCOLOR" to "00000D6D".   Property index: 0
      $03020101, $00000002,   //set property:  "ArrowDir" of "BYTE" to "CLeftArrow".   Property index: 1

      $01024001, $002200B1, $001E001E,   //create Arrow2(1, 177, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00000D6D,   //set property:  "Color" of "TCOLOR" to "00000D6D".   Property index: 0
      $03020101, $00000003,   //set property:  "ArrowDir" of "BYTE" to "CRightArrow".   Property index: 1

      $01024001, $0022010F, $001E001E,   //create Arrow3(1, 271, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00000D6D,   //set property:  "Color" of "TCOLOR" to "00000D6D".   Property index: 0

      $01024001, $00220139, $001E001E,   //create Arrow4(1, 313, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00000D6D,   //set property:  "Color" of "TCOLOR" to "00000D6D".   Property index: 0
      $03020101, $00000001,   //set property:  "ArrowDir" of "BYTE" to "CDownArrow".   Property index: 1

      $01034001, $00550069, $00620112,   //create Panel1(1, 105, 85, 274, 98)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03030004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03038107, $656E6150, $0031206C,   //set property:  "Caption" of "STRING" to "Panel 1".   Property index: 1
      $03030204, $00006D6D,   //set property:  "Color" of "TCOLOR" to "00006D6D".   Property index: 2
      $03030304, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 3

      $01024001, $00A50011, $002D002D,   //create Arrow5(1, 17, 165, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00003734,   //set property:  "Color" of "TCOLOR" to "00003734".   Property index: 0

      $01024001, $00DD0011, $002D002D,   //create Arrow6(1, 17, 221, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00003734,   //set property:  "Color" of "TCOLOR" to "00003734".   Property index: 0
      $03020101, $00000001,   //set property:  "ArrowDir" of "BYTE" to "CDownArrow".   Property index: 1

      $01024001, $00A501A1, $002D002D,   //create Arrow7(1, 417, 165, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00003734,   //set property:  "Color" of "TCOLOR" to "00003734".   Property index: 0
      $03020101, $00000002,   //set property:  "ArrowDir" of "BYTE" to "CLeftArrow".   Property index: 1

      $01024001, $00DD01A1, $002D002D,   //create Arrow8(1, 417, 221, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00003734,   //set property:  "Color" of "TCOLOR" to "00003734".   Property index: 0
      $03020101, $00000003,   //set property:  "ArrowDir" of "BYTE" to "CRightArrow".   Property index: 1

      $01014001, $00BD00A9, $00230094,   //create btn3(1, 169, 189, 148, 35)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03010201, $00000000,   //set property:  "BaseProps.Enabled" of "BYTE" to "0".   Property index: 2
      $03010304, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 3
      $03018011, $61736944, $64656C62, $74754220, $206E6F74, $00000033,   //set property:  "Caption" of "STRING" to "Disabled Button 3".   Property index: 0

      $01014001, $00E500A9, $00230094,   //create btn4(1, 169, 229, 148, 35)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03010201, $00000000,   //set property:  "BaseProps.Enabled" of "BYTE" to "0".   Property index: 2
      $03010304, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 3
      $03018011, $61736944, $64656C62, $74754220, $206E6F74, $00000034,   //set property:  "Caption" of "STRING" to "Disabled Button 4".   Property index: 0

      $01024001, $001D00D8, $002D002D,   //create Arrow9(1, 216, 29, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $0000EF7F,   //set property:  "Color" of "TCOLOR" to "0000EF7F".   Property index: 0
      $03020101, $00000004,   //set property:  "ArrowDir" of "BYTE" to "CUndefinedArrow".   Property index: 1

      $01044102, $001D0019, $0019008C,   //create CheckBox1(2, 25, 29, 140, 25)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0304800A, $63656843, $786F426B, $00003120,   //set property:  "Caption" of "STRING" to "CheckBox 1".   Property index: 0
      $03040104, $00009417,   //set property:  "Color" of "TCOLOR" to "00009417".   Property index: 1
      $03040204, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 2

      $01044102, $00450019, $0019008C,   //create CheckBox2(2, 25, 69, 140, 25)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0304800A, $63656843, $786F426B, $00003220,   //set property:  "Caption" of "STRING" to "CheckBox 2".   Property index: 0
      $03040104, $00009417,   //set property:  "Color" of "TCOLOR" to "00009417".   Property index: 1
      $03040204, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 2

      $01044102, $001D00F9, $0019008C,   //create CheckBox3(2, 249, 29, 140, 25)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03040301, $00000000,   //set property:  "BaseProps.Enabled" of "BYTE" to "0".   Property index: 3
      $0304800A, $63656843, $786F426B, $00003320,   //set property:  "Caption" of "STRING" to "CheckBox 3".   Property index: 0
      $03040104, $00009417,   //set property:  "Color" of "TCOLOR" to "00009417".   Property index: 1
      $03040204, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 2

      $01054102, $00ED0019, $00140199,   //create ScrollBar1(2, 25, 237, 409, 20)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0

      $01054102, $001D01B9, $00D00014,   //create ScrollBar2(2, 441, 29, 20, 208)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03050001, $00000001,   //set property:  "Direction" of "BYTE" to "CScrollBarVertDir".   Property index: 0

      $01074102, $006D0019, $006F008C,   //create ListBox1(2, 25, 109, 140, 111)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03070004, $0000BD7F,   //set property:  "Items^.BackgroundColor" of "TCOLOR" to "0000BD7F".   Property index: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C02, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01074102, $006D00F9, $006F008C,   //create ListBox3(2, 249, 109, 140, 111)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C02, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01014102, $003F00F9, $0026008C,   //create DynTFTButton0(2, 249, 63, 140, 38)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03018004, $306E7462,   //set property:  "Caption" of "STRING" to "btn0".   Property index: 0
      $03810404, $00000000,   //set property:  "ActiveFont" of "PBYTE" to "Verdana29x32_ItalicUnderLine".  Set to index of "Verdana29x32_ItalicUnderLine".   Property index: 4
      $03810504, $00000001,   //set property:  "BaseProps.OnMouseUpUser" of "PBYTE" to "DynTFTButton0_OnMouseUpUser".  Set to index of "DynTFTButton0_OnMouseUpUser".   Property index: 5

      $01084203, $001D0009, $001E0050,   //create lbl1(3, 9, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0031206C,   //set property:  "Caption" of "STRING" to "Label 1".   Property index: 1
      $03080204, $0000841F,   //set property:  "Color" of "TCOLOR" to "0000841F".   Property index: 2

      $01084203, $001D0081, $001E0050,   //create lbl2(3, 129, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0032206C,   //set property:  "Caption" of "STRING" to "Label 2".   Property index: 1
      $03080204, $0000841F,   //set property:  "Color" of "TCOLOR" to "0000841F".   Property index: 2

      $01084203, $001D0109, $001E0050,   //create lbl3(3, 265, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0033206C,   //set property:  "Caption" of "STRING" to "Label 3".   Property index: 1
      $03080204, $0000841F,   //set property:  "Color" of "TCOLOR" to "0000841F".   Property index: 2

      $01084203, $001D0181, $001E0050,   //create lbl4(3, 385, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0034206C,   //set property:  "Caption" of "STRING" to "Label 4".   Property index: 1
      $03080204, $0000841F,   //set property:  "Color" of "TCOLOR" to "0000841F".   Property index: 2

      $010F4304, $00370001, $00B8013E,   //create vkTest(4, 1, 55, 318, 184)  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $038F0004, $00000002,   //set property:  "OnCharKey" of "PBYTE" to "VirtualKeyboard_OnCharKey".  Set to index of "VirtualKeyboard_OnCharKey".   Property index: 0
      $038F0104, $00000003,   //set property:  "OnSpecialKey" of "PBYTE" to "VirtualKeyboard_OnSpecialKey".  Set to index of "VirtualKeyboard_OnSpecialKey".   Property index: 1

      $010D4304, $001B0009, $001800C8,   //create Edit1(4, 9, 27, 200, 24)  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $030D8005, $74696445, $00000031,   //set property:  "Text" of "STRING" to "Edit1".   Property index: 0

      $01104405, $001D0009, $001600A0,   //create ComboBox1(5, 9, 29, 160, 22)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03100004, $00006FDF,   //set property:  "ListBox^.Items^.BackgroundColor" of "TCOLOR" to "00006FDF".   Property index: 0
      $03108103, $00656E6F,   //set property:  "ListBox^.Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03108203, $006F7774,   //set property:  "ListBox^.Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03108305, $65726874, $00000065,   //set property:  "ListBox^.Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03108404, $72756F66,   //set property:  "ListBox^.Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03108504, $65766966,   //set property:  "ListBox^.Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03108603, $00786973,   //set property:  "ListBox^.Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03108705, $65766573, $0000006E,   //set property:  "ListBox^.Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03108805, $68676965, $00000074,   //set property:  "ListBox^.Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03108904, $656E696E,   //set property:  "ListBox^.Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03108A03, $006E6574,   //set property:  "ListBox^.Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03100B02, $0000000F,   //set property:  "ListBox^.Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03100C04, $00006FDF,   //set property:  "Edit^.Color" of "TCOLOR" to "00006FDF".   Property index: 12
      $03100D04, $00000000,   //set property:  "Editable" of "BOOLEAN" to "False".   Property index: 13
      $03100E02, $0000000A,   //set property:  "ListBox^.Items^.Count" of "INTEGER" to "10".   Property index: 14
      // Property ListBox^.Items^.TotalVisibleCount skipped because of compiler directives.
      // Property ListBox^.Items^.OnGetItem skipped because of compiler directives.

      $01104405, $004D0009, $001800A0,   //create ComboBox2(5, 9, 77, 160, 24)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03100004, $00006FDF,   //set property:  "ListBox^.Items^.BackgroundColor" of "TCOLOR" to "00006FDF".   Property index: 0
      $03108103, $00656E6F,   //set property:  "ListBox^.Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03108203, $006F7774,   //set property:  "ListBox^.Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03108305, $65726874, $00000065,   //set property:  "ListBox^.Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03108404, $72756F66,   //set property:  "ListBox^.Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03108504, $65766966,   //set property:  "ListBox^.Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03108603, $00786973,   //set property:  "ListBox^.Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03108705, $65766573, $0000006E,   //set property:  "ListBox^.Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03108805, $68676965, $00000074,   //set property:  "ListBox^.Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03108904, $656E696E,   //set property:  "ListBox^.Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03108A03, $006E6574,   //set property:  "ListBox^.Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03100B02, $0000000F,   //set property:  "ListBox^.Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03100E02, $0000000A,   //set property:  "ListBox^.Items^.Count" of "INTEGER" to "10".   Property index: 14
      // Property ListBox^.Items^.TotalVisibleCount skipped because of compiler directives.
      // Property ListBox^.Items^.OnGetItem skipped because of compiler directives.

      $01084405, $004D00C1, $00180050,   //create Label4(5, 193, 77, 80, 24)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088108, $74696445, $656C6261,   //set property:  "Caption" of "STRING" to "Editable".   Property index: 1
      $03080204, $00000659,   //set property:  "Color" of "TCOLOR" to "00000659".   Property index: 2
      $03080304, $0000FFFF,   //set property:  "Font_Color" of "TCOLOR" to "0000FFFF".   Property index: 3

      $01084405, $001D00C1, $00180082,   //create Label5(5, 193, 29, 130, 24)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $0308810F, $656C6553, $62617463, $6F20656C, $00796C6E,   //set property:  "Caption" of "STRING" to "Selectable only".   Property index: 1
      $03080204, $00000659,   //set property:  "Color" of "TCOLOR" to "00000659".   Property index: 2
      $03080304, $0000FFFF,   //set property:  "Font_Color" of "TCOLOR" to "0000FFFF".   Property index: 3

      $01074405, $00850009, $007800A0,   //create ListBox2(5, 9, 133, 160, 120)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03070004, $0000079E,   //set property:  "Items^.BackgroundColor" of "TCOLOR" to "0000079E".   Property index: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C02, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01074405, $008500F9, $007800A0,   //create ListBox4(5, 249, 133, 160, 120)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03070004, $0000079E,   //set property:  "Items^.BackgroundColor" of "TCOLOR" to "0000079E".   Property index: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C02, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01114506, $00210009, $001800C8,   //create TrackBar1(6, 9, 33, 200, 24)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03110002, $00000003,   //set property:  "Position" of "INTEGER" to "3".   Property index: 0
      $03910104, $00000004,   //set property:  "OnTrackBarChange" of "PBYTE" to "TrackBar1_OnTrackBarChange".  Set to index of "TrackBar1_OnTrackBarChange".   Property index: 1

      $01114506, $005D0019, $00A00018,   //create TrackBar2(6, 25, 93, 24, 160)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03110002, $00000007,   //set property:  "Position" of "INTEGER" to "7".   Property index: 0
      $03110201, $00000001,   //set property:  "Orientation" of "BYTE" to "CTrackBarVertDir".   Property index: 2
      $03910104, $00000005,   //set property:  "OnTrackBarChange" of "PBYTE" to "TrackBar2_OnTrackBarChange".  Set to index of "TrackBar2_OnTrackBarChange".   Property index: 1

      $01124506, $002D0101, $001400CC,   //create ProgressBar1(6, 257, 45, 204, 20)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03120004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03120102, $00000003,   //set property:  "Position" of "INTEGER" to "3".   Property index: 1

      $01124506, $005D0101, $00A00018,   //create ProgressBar2(6, 257, 93, 24, 160)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03120004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03120102, $00000007,   //set property:  "Position" of "INTEGER" to "7".   Property index: 1
      $03120201, $00000001,   //set property:  "Orientation" of "BYTE" to "CProgressBarVertDir".   Property index: 2

      $01014506, $00C80049, $00190068,   //create btnShowMessageBox(6, 73, 200, 104, 25)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0301800B, $7373654D, $20656761, $00786F42,   //set property:  "Caption" of "STRING" to "Message Box".   Property index: 0
      $03810504, $00000006,   //set property:  "BaseProps.OnMouseUpUser" of "PBYTE" to "btnShowMessageBox_OnMouseUpUser".  Set to index of "btnShowMessageBox_OnMouseUpUser".   Property index: 5
      0  //stop execution
    );
  {$ENDIF} {$ENDIF} // IsMCU PIC32AppAddrArr

  {$IFDEF IsMCU} {$IFDEF PIC32AppWithSDCard} // Profile: "PIC32AppWithSDCard"   HandlersLocation: Lst file
    C_RTTI_CreateInstructionData: array[0..480] of DWord = (
      $04000005,   //Set build number to 5

      $01014001, $001D0009, $0028006E,   //create btn1(1, 9, 29, 110, 40)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03018008, $74747542, $31206E6F,   //set property:  "Caption" of "STRING" to "Button 1".   Property index: 0
      $03010104, $00000D6D,   //set property:  "Font_Color" of "TCOLOR" to "00000D6D".   Property index: 1

      $01014001, $001D0169, $0028006E,   //create btn2(1, 361, 29, 110, 40)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03018008, $74747542, $32206E6F,   //set property:  "Caption" of "STRING" to "Button 2".   Property index: 0
      $03010104, $00000D6D,   //set property:  "Font_Color" of "TCOLOR" to "00000D6D".   Property index: 1

      $01024001, $00220089, $001E001E,   //create Arrow1(1, 137, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00000D6D,   //set property:  "Color" of "TCOLOR" to "00000D6D".   Property index: 0
      $03020101, $00000002,   //set property:  "ArrowDir" of "BYTE" to "CLeftArrow".   Property index: 1

      $01024001, $002200B1, $001E001E,   //create Arrow2(1, 177, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00000D6D,   //set property:  "Color" of "TCOLOR" to "00000D6D".   Property index: 0
      $03020101, $00000003,   //set property:  "ArrowDir" of "BYTE" to "CRightArrow".   Property index: 1

      $01024001, $0022010F, $001E001E,   //create Arrow3(1, 271, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00000D6D,   //set property:  "Color" of "TCOLOR" to "00000D6D".   Property index: 0

      $01024001, $00220139, $001E001E,   //create Arrow4(1, 313, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00000D6D,   //set property:  "Color" of "TCOLOR" to "00000D6D".   Property index: 0
      $03020101, $00000001,   //set property:  "ArrowDir" of "BYTE" to "CDownArrow".   Property index: 1

      $01034001, $00550069, $00620112,   //create Panel1(1, 105, 85, 274, 98)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03030004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03038107, $656E6150, $0031206C,   //set property:  "Caption" of "STRING" to "Panel 1".   Property index: 1
      $03030204, $00006D6D,   //set property:  "Color" of "TCOLOR" to "00006D6D".   Property index: 2
      $03030304, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 3

      $01024001, $00A50011, $002D002D,   //create Arrow5(1, 17, 165, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00003734,   //set property:  "Color" of "TCOLOR" to "00003734".   Property index: 0

      $01024001, $00DD0011, $002D002D,   //create Arrow6(1, 17, 221, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00003734,   //set property:  "Color" of "TCOLOR" to "00003734".   Property index: 0
      $03020101, $00000001,   //set property:  "ArrowDir" of "BYTE" to "CDownArrow".   Property index: 1

      $01024001, $00A501A1, $002D002D,   //create Arrow7(1, 417, 165, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00003734,   //set property:  "Color" of "TCOLOR" to "00003734".   Property index: 0
      $03020101, $00000002,   //set property:  "ArrowDir" of "BYTE" to "CLeftArrow".   Property index: 1

      $01024001, $00DD01A1, $002D002D,   //create Arrow8(1, 417, 221, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00003734,   //set property:  "Color" of "TCOLOR" to "00003734".   Property index: 0
      $03020101, $00000003,   //set property:  "ArrowDir" of "BYTE" to "CRightArrow".   Property index: 1

      $01014001, $00BD00A9, $00230094,   //create btn3(1, 169, 189, 148, 35)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03010201, $00000000,   //set property:  "BaseProps.Enabled" of "BYTE" to "0".   Property index: 2
      $03010304, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 3
      $03018011, $61736944, $64656C62, $74754220, $206E6F74, $00000033,   //set property:  "Caption" of "STRING" to "Disabled Button 3".   Property index: 0

      $01014001, $00E500A9, $00230094,   //create btn4(1, 169, 229, 148, 35)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03010201, $00000000,   //set property:  "BaseProps.Enabled" of "BYTE" to "0".   Property index: 2
      $03010304, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 3
      $03018011, $61736944, $64656C62, $74754220, $206E6F74, $00000034,   //set property:  "Caption" of "STRING" to "Disabled Button 4".   Property index: 0

      $01024001, $001D00D8, $002D002D,   //create Arrow9(1, 216, 29, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $0000EF7F,   //set property:  "Color" of "TCOLOR" to "0000EF7F".   Property index: 0
      $03020101, $00000004,   //set property:  "ArrowDir" of "BYTE" to "CUndefinedArrow".   Property index: 1

      $01044102, $001D0019, $0019008C,   //create CheckBox1(2, 25, 29, 140, 25)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0304800A, $63656843, $786F426B, $00003120,   //set property:  "Caption" of "STRING" to "CheckBox 1".   Property index: 0
      $03040104, $00009417,   //set property:  "Color" of "TCOLOR" to "00009417".   Property index: 1
      $03040204, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 2

      $01044102, $00450019, $0019008C,   //create CheckBox2(2, 25, 69, 140, 25)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0304800A, $63656843, $786F426B, $00003220,   //set property:  "Caption" of "STRING" to "CheckBox 2".   Property index: 0
      $03040104, $00009417,   //set property:  "Color" of "TCOLOR" to "00009417".   Property index: 1
      $03040204, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 2

      $01044102, $001D00F9, $0019008C,   //create CheckBox3(2, 249, 29, 140, 25)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03040301, $00000000,   //set property:  "BaseProps.Enabled" of "BYTE" to "0".   Property index: 3
      $0304800A, $63656843, $786F426B, $00003320,   //set property:  "Caption" of "STRING" to "CheckBox 3".   Property index: 0
      $03040104, $00009417,   //set property:  "Color" of "TCOLOR" to "00009417".   Property index: 1
      $03040204, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 2

      $01054102, $00ED0019, $00140199,   //create ScrollBar1(2, 25, 237, 409, 20)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0

      $01054102, $001D01B9, $00D00014,   //create ScrollBar2(2, 441, 29, 20, 208)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03050001, $00000001,   //set property:  "Direction" of "BYTE" to "CScrollBarVertDir".   Property index: 0

      $01074102, $006D0019, $006F008C,   //create ListBox1(2, 25, 109, 140, 111)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03070004, $0000BD7F,   //set property:  "Items^.BackgroundColor" of "TCOLOR" to "0000BD7F".   Property index: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C02, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01074102, $006D00F9, $006F008C,   //create ListBox3(2, 249, 109, 140, 111)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C02, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01014102, $003F00F9, $0026008C,   //create DynTFTButton0(2, 249, 63, 140, 38)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03018004, $306E7462,   //set property:  "Caption" of "STRING" to "btn0".   Property index: 0
      $03010404, $9D021688,   //set property:  "ActiveFont" of "PBYTE" to "Verdana29x32_ItalicUnderLine".   Property index: 4
      $03010504, $9D01B90C,   //set property:  "BaseProps.OnMouseUpUser" of "PBYTE" to "DynTFTButton0_OnMouseUpUser".   Property index: 5

      $01084203, $001D0009, $001E0050,   //create lbl1(3, 9, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0031206C,   //set property:  "Caption" of "STRING" to "Label 1".   Property index: 1
      $03080204, $0000841F,   //set property:  "Color" of "TCOLOR" to "0000841F".   Property index: 2

      $01084203, $001D0081, $001E0050,   //create lbl2(3, 129, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0032206C,   //set property:  "Caption" of "STRING" to "Label 2".   Property index: 1
      $03080204, $0000841F,   //set property:  "Color" of "TCOLOR" to "0000841F".   Property index: 2

      $01084203, $001D0109, $001E0050,   //create lbl3(3, 265, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0033206C,   //set property:  "Caption" of "STRING" to "Label 3".   Property index: 1
      $03080204, $0000841F,   //set property:  "Color" of "TCOLOR" to "0000841F".   Property index: 2

      $01084203, $001D0181, $001E0050,   //create lbl4(3, 385, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0034206C,   //set property:  "Caption" of "STRING" to "Label 4".   Property index: 1
      $03080204, $0000841F,   //set property:  "Color" of "TCOLOR" to "0000841F".   Property index: 2

      $010F4304, $00370001, $00B8013E,   //create vkTest(4, 1, 55, 318, 184)  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $030F0004, $9D01BC60,   //set property:  "OnCharKey" of "PBYTE" to "VirtualKeyboard_OnCharKey".   Property index: 0
      $030F0104, $9D01E4D4,   //set property:  "OnSpecialKey" of "PBYTE" to "VirtualKeyboard_OnSpecialKey".   Property index: 1

      $010D4304, $001B0009, $001800C8,   //create Edit1(4, 9, 27, 200, 24)  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $030D8005, $74696445, $00000031,   //set property:  "Text" of "STRING" to "Edit1".   Property index: 0

      $01104405, $001D0009, $001600A0,   //create ComboBox1(5, 9, 29, 160, 22)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03100004, $00006FDF,   //set property:  "ListBox^.Items^.BackgroundColor" of "TCOLOR" to "00006FDF".   Property index: 0
      $03108103, $00656E6F,   //set property:  "ListBox^.Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03108203, $006F7774,   //set property:  "ListBox^.Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03108305, $65726874, $00000065,   //set property:  "ListBox^.Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03108404, $72756F66,   //set property:  "ListBox^.Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03108504, $65766966,   //set property:  "ListBox^.Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03108603, $00786973,   //set property:  "ListBox^.Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03108705, $65766573, $0000006E,   //set property:  "ListBox^.Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03108805, $68676965, $00000074,   //set property:  "ListBox^.Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03108904, $656E696E,   //set property:  "ListBox^.Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03108A03, $006E6574,   //set property:  "ListBox^.Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03100B02, $0000000F,   //set property:  "ListBox^.Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03100C04, $00006FDF,   //set property:  "Edit^.Color" of "TCOLOR" to "00006FDF".   Property index: 12
      $03100D04, $00000000,   //set property:  "Editable" of "BOOLEAN" to "False".   Property index: 13
      $03100E02, $0000000A,   //set property:  "ListBox^.Items^.Count" of "INTEGER" to "10".   Property index: 14
      // Property ListBox^.Items^.TotalVisibleCount skipped because of compiler directives.
      // Property ListBox^.Items^.OnGetItem skipped because of compiler directives.

      $01104405, $004D0009, $001800A0,   //create ComboBox2(5, 9, 77, 160, 24)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03100004, $00006FDF,   //set property:  "ListBox^.Items^.BackgroundColor" of "TCOLOR" to "00006FDF".   Property index: 0
      $03108103, $00656E6F,   //set property:  "ListBox^.Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03108203, $006F7774,   //set property:  "ListBox^.Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03108305, $65726874, $00000065,   //set property:  "ListBox^.Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03108404, $72756F66,   //set property:  "ListBox^.Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03108504, $65766966,   //set property:  "ListBox^.Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03108603, $00786973,   //set property:  "ListBox^.Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03108705, $65766573, $0000006E,   //set property:  "ListBox^.Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03108805, $68676965, $00000074,   //set property:  "ListBox^.Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03108904, $656E696E,   //set property:  "ListBox^.Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03108A03, $006E6574,   //set property:  "ListBox^.Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03100B02, $0000000F,   //set property:  "ListBox^.Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03100E02, $0000000A,   //set property:  "ListBox^.Items^.Count" of "INTEGER" to "10".   Property index: 14
      // Property ListBox^.Items^.TotalVisibleCount skipped because of compiler directives.
      // Property ListBox^.Items^.OnGetItem skipped because of compiler directives.

      $01084405, $004D00C1, $00180050,   //create Label4(5, 193, 77, 80, 24)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088108, $74696445, $656C6261,   //set property:  "Caption" of "STRING" to "Editable".   Property index: 1
      $03080204, $00000659,   //set property:  "Color" of "TCOLOR" to "00000659".   Property index: 2
      $03080304, $0000FFFF,   //set property:  "Font_Color" of "TCOLOR" to "0000FFFF".   Property index: 3

      $01084405, $001D00C1, $00180082,   //create Label5(5, 193, 29, 130, 24)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $0308810F, $656C6553, $62617463, $6F20656C, $00796C6E,   //set property:  "Caption" of "STRING" to "Selectable only".   Property index: 1
      $03080204, $00000659,   //set property:  "Color" of "TCOLOR" to "00000659".   Property index: 2
      $03080304, $0000FFFF,   //set property:  "Font_Color" of "TCOLOR" to "0000FFFF".   Property index: 3

      $01074405, $00850009, $007800A0,   //create ListBox2(5, 9, 133, 160, 120)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03070004, $0000079E,   //set property:  "Items^.BackgroundColor" of "TCOLOR" to "0000079E".   Property index: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C02, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01074405, $008500F9, $007800A0,   //create ListBox4(5, 249, 133, 160, 120)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03070004, $0000079E,   //set property:  "Items^.BackgroundColor" of "TCOLOR" to "0000079E".   Property index: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C02, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01114506, $00210009, $001800C8,   //create TrackBar1(6, 9, 33, 200, 24)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03110002, $00000003,   //set property:  "Position" of "INTEGER" to "3".   Property index: 0
      $03110104, $9D01E454,   //set property:  "OnTrackBarChange" of "PBYTE" to "TrackBar1_OnTrackBarChange".   Property index: 1

      $01114506, $005D0019, $00A00018,   //create TrackBar2(6, 25, 93, 24, 160)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03110002, $00000007,   //set property:  "Position" of "INTEGER" to "7".   Property index: 0
      $03110201, $00000001,   //set property:  "Orientation" of "BYTE" to "CTrackBarVertDir".   Property index: 2
      $03110104, $9D01BFA4,   //set property:  "OnTrackBarChange" of "PBYTE" to "TrackBar2_OnTrackBarChange".   Property index: 1

      $01124506, $002D0101, $001400CC,   //create ProgressBar1(6, 257, 45, 204, 20)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03120004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03120102, $00000003,   //set property:  "Position" of "INTEGER" to "3".   Property index: 1

      $01124506, $005D0101, $00A00018,   //create ProgressBar2(6, 257, 93, 24, 160)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03120004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03120102, $00000007,   //set property:  "Position" of "INTEGER" to "7".   Property index: 1
      $03120201, $00000001,   //set property:  "Orientation" of "BYTE" to "CProgressBarVertDir".   Property index: 2

      $01014506, $00C80049, $00190068,   //create btnShowMessageBox(6, 73, 200, 104, 25)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0301800B, $7373654D, $20656761, $00786F42,   //set property:  "Caption" of "STRING" to "Message Box".   Property index: 0
      $03010504, $9D01B9E4,   //set property:  "BaseProps.OnMouseUpUser" of "PBYTE" to "btnShowMessageBox_OnMouseUpUser".   Property index: 5
      0  //stop execution
    );
  {$ENDIF} {$ENDIF} // IsMCU PIC32AppWithSDCard

  {$IFDEF IsMCU} {$IFDEF PIC32AppDWithSDCard} // Profile: "PIC32AppDWithSDCard"   HandlersLocation: Lst file
    C_RTTI_CreateInstructionData: array[0..480] of DWord = (
      $04000005,   //Set build number to 5

      $01014001, $001D0009, $0028006E,   //create btn1(1, 9, 29, 110, 40)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03018008, $74747542, $31206E6F,   //set property:  "Caption" of "STRING" to "Button 1".   Property index: 0
      $03010104, $00000D6D,   //set property:  "Font_Color" of "TCOLOR" to "00000D6D".   Property index: 1

      $01014001, $001D0169, $0028006E,   //create btn2(1, 361, 29, 110, 40)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03018008, $74747542, $32206E6F,   //set property:  "Caption" of "STRING" to "Button 2".   Property index: 0
      $03010104, $00000D6D,   //set property:  "Font_Color" of "TCOLOR" to "00000D6D".   Property index: 1

      $01024001, $00220089, $001E001E,   //create Arrow1(1, 137, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00000D6D,   //set property:  "Color" of "TCOLOR" to "00000D6D".   Property index: 0
      $03020101, $00000002,   //set property:  "ArrowDir" of "BYTE" to "CLeftArrow".   Property index: 1

      $01024001, $002200B1, $001E001E,   //create Arrow2(1, 177, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00000D6D,   //set property:  "Color" of "TCOLOR" to "00000D6D".   Property index: 0
      $03020101, $00000003,   //set property:  "ArrowDir" of "BYTE" to "CRightArrow".   Property index: 1

      $01024001, $0022010F, $001E001E,   //create Arrow3(1, 271, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00000D6D,   //set property:  "Color" of "TCOLOR" to "00000D6D".   Property index: 0

      $01024001, $00220139, $001E001E,   //create Arrow4(1, 313, 34, 30, 30)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00000D6D,   //set property:  "Color" of "TCOLOR" to "00000D6D".   Property index: 0
      $03020101, $00000001,   //set property:  "ArrowDir" of "BYTE" to "CDownArrow".   Property index: 1

      $01034001, $00550069, $00620112,   //create Panel1(1, 105, 85, 274, 98)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03030004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03038107, $656E6150, $0031206C,   //set property:  "Caption" of "STRING" to "Panel 1".   Property index: 1
      $03030204, $00006D6D,   //set property:  "Color" of "TCOLOR" to "00006D6D".   Property index: 2
      $03030304, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 3

      $01024001, $00A50011, $002D002D,   //create Arrow5(1, 17, 165, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00003734,   //set property:  "Color" of "TCOLOR" to "00003734".   Property index: 0

      $01024001, $00DD0011, $002D002D,   //create Arrow6(1, 17, 221, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00003734,   //set property:  "Color" of "TCOLOR" to "00003734".   Property index: 0
      $03020101, $00000001,   //set property:  "ArrowDir" of "BYTE" to "CDownArrow".   Property index: 1

      $01024001, $00A501A1, $002D002D,   //create Arrow7(1, 417, 165, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00003734,   //set property:  "Color" of "TCOLOR" to "00003734".   Property index: 0
      $03020101, $00000002,   //set property:  "ArrowDir" of "BYTE" to "CLeftArrow".   Property index: 1

      $01024001, $00DD01A1, $002D002D,   //create Arrow8(1, 417, 221, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $00003734,   //set property:  "Color" of "TCOLOR" to "00003734".   Property index: 0
      $03020101, $00000003,   //set property:  "ArrowDir" of "BYTE" to "CRightArrow".   Property index: 1

      $01014001, $00BD00A9, $00230094,   //create btn3(1, 169, 189, 148, 35)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03010201, $00000000,   //set property:  "BaseProps.Enabled" of "BYTE" to "0".   Property index: 2
      $03010304, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 3
      $03018011, $61736944, $64656C62, $74754220, $206E6F74, $00000033,   //set property:  "Caption" of "STRING" to "Disabled Button 3".   Property index: 0

      $01014001, $00E500A9, $00230094,   //create btn4(1, 169, 229, 148, 35)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03010201, $00000000,   //set property:  "BaseProps.Enabled" of "BYTE" to "0".   Property index: 2
      $03010304, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 3
      $03018011, $61736944, $64656C62, $74754220, $206E6F74, $00000034,   //set property:  "Caption" of "STRING" to "Disabled Button 4".   Property index: 0

      $01024001, $001D00D8, $002D002D,   //create Arrow9(1, 216, 29, 45, 45)  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03020004, $0000EF7F,   //set property:  "Color" of "TCOLOR" to "0000EF7F".   Property index: 0
      $03020101, $00000004,   //set property:  "ArrowDir" of "BYTE" to "CUndefinedArrow".   Property index: 1

      $01044102, $001D0019, $0019008C,   //create CheckBox1(2, 25, 29, 140, 25)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0304800A, $63656843, $786F426B, $00003120,   //set property:  "Caption" of "STRING" to "CheckBox 1".   Property index: 0
      $03040104, $00009417,   //set property:  "Color" of "TCOLOR" to "00009417".   Property index: 1
      $03040204, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 2

      $01044102, $00450019, $0019008C,   //create CheckBox2(2, 25, 69, 140, 25)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0304800A, $63656843, $786F426B, $00003220,   //set property:  "Caption" of "STRING" to "CheckBox 2".   Property index: 0
      $03040104, $00009417,   //set property:  "Color" of "TCOLOR" to "00009417".   Property index: 1
      $03040204, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 2

      $01044102, $001D00F9, $0019008C,   //create CheckBox3(2, 249, 29, 140, 25)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03040301, $00000000,   //set property:  "BaseProps.Enabled" of "BYTE" to "0".   Property index: 3
      $0304800A, $63656843, $786F426B, $00003320,   //set property:  "Caption" of "STRING" to "CheckBox 3".   Property index: 0
      $03040104, $00009417,   //set property:  "Color" of "TCOLOR" to "00009417".   Property index: 1
      $03040204, $00000000,   //set property:  "Font_Color" of "TCOLOR" to "00000000".   Property index: 2

      $01054102, $00ED0019, $00140199,   //create ScrollBar1(2, 25, 237, 409, 20)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0

      $01054102, $001D01B9, $00D00014,   //create ScrollBar2(2, 441, 29, 20, 208)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03050001, $00000001,   //set property:  "Direction" of "BYTE" to "CScrollBarVertDir".   Property index: 0

      $01074102, $006D0019, $006F008C,   //create ListBox1(2, 25, 109, 140, 111)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03070004, $0000BD7F,   //set property:  "Items^.BackgroundColor" of "TCOLOR" to "0000BD7F".   Property index: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C02, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01074102, $006D00F9, $006F008C,   //create ListBox3(2, 249, 109, 140, 111)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C02, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01014102, $003F00F9, $0026008C,   //create DynTFTButton0(2, 249, 63, 140, 38)  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03018004, $306E7462,   //set property:  "Caption" of "STRING" to "btn0".   Property index: 0
      $03010404, $9D01F8D0,   //set property:  "ActiveFont" of "PBYTE" to "Verdana29x32_ItalicUnderLine".   Property index: 4
      $03010504, $9D01A6E8,   //set property:  "BaseProps.OnMouseUpUser" of "PBYTE" to "DynTFTButton0_OnMouseUpUser".   Property index: 5

      $01084203, $001D0009, $001E0050,   //create lbl1(3, 9, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0031206C,   //set property:  "Caption" of "STRING" to "Label 1".   Property index: 1
      $03080204, $0000841F,   //set property:  "Color" of "TCOLOR" to "0000841F".   Property index: 2

      $01084203, $001D0081, $001E0050,   //create lbl2(3, 129, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0032206C,   //set property:  "Caption" of "STRING" to "Label 2".   Property index: 1
      $03080204, $0000841F,   //set property:  "Color" of "TCOLOR" to "0000841F".   Property index: 2

      $01084203, $001D0109, $001E0050,   //create lbl3(3, 265, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0033206C,   //set property:  "Caption" of "STRING" to "Label 3".   Property index: 1
      $03080204, $0000841F,   //set property:  "Color" of "TCOLOR" to "0000841F".   Property index: 2

      $01084203, $001D0181, $001E0050,   //create lbl4(3, 385, 29, 80, 30)  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088107, $6562614C, $0034206C,   //set property:  "Caption" of "STRING" to "Label 4".   Property index: 1
      $03080204, $0000841F,   //set property:  "Color" of "TCOLOR" to "0000841F".   Property index: 2

      $010F4304, $00370001, $00B8013E,   //create vkTest(4, 1, 55, 318, 184)  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $030F0004, $9D01AF80,   //set property:  "OnCharKey" of "PBYTE" to "VirtualKeyboard_OnCharKey".   Property index: 0
      $030F0104, $9D01AE7C,   //set property:  "OnSpecialKey" of "PBYTE" to "VirtualKeyboard_OnSpecialKey".   Property index: 1

      $010D4304, $001B0009, $001800C8,   //create Edit1(4, 9, 27, 200, 24)  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $030D8005, $74696445, $00000031,   //set property:  "Text" of "STRING" to "Edit1".   Property index: 0

      $01104405, $001D0009, $001600A0,   //create ComboBox1(5, 9, 29, 160, 22)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03100004, $00006FDF,   //set property:  "ListBox^.Items^.BackgroundColor" of "TCOLOR" to "00006FDF".   Property index: 0
      $03108103, $00656E6F,   //set property:  "ListBox^.Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03108203, $006F7774,   //set property:  "ListBox^.Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03108305, $65726874, $00000065,   //set property:  "ListBox^.Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03108404, $72756F66,   //set property:  "ListBox^.Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03108504, $65766966,   //set property:  "ListBox^.Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03108603, $00786973,   //set property:  "ListBox^.Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03108705, $65766573, $0000006E,   //set property:  "ListBox^.Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03108805, $68676965, $00000074,   //set property:  "ListBox^.Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03108904, $656E696E,   //set property:  "ListBox^.Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03108A03, $006E6574,   //set property:  "ListBox^.Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03100B02, $0000000F,   //set property:  "ListBox^.Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03100C04, $00006FDF,   //set property:  "Edit^.Color" of "TCOLOR" to "00006FDF".   Property index: 12
      $03100D04, $00000000,   //set property:  "Editable" of "BOOLEAN" to "False".   Property index: 13
      $03100E02, $0000000A,   //set property:  "ListBox^.Items^.Count" of "INTEGER" to "10".   Property index: 14
      // Property ListBox^.Items^.TotalVisibleCount skipped because of compiler directives.
      // Property ListBox^.Items^.OnGetItem skipped because of compiler directives.

      $01104405, $004D0009, $001800A0,   //create ComboBox2(5, 9, 77, 160, 24)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03100004, $00006FDF,   //set property:  "ListBox^.Items^.BackgroundColor" of "TCOLOR" to "00006FDF".   Property index: 0
      $03108103, $00656E6F,   //set property:  "ListBox^.Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03108203, $006F7774,   //set property:  "ListBox^.Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03108305, $65726874, $00000065,   //set property:  "ListBox^.Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03108404, $72756F66,   //set property:  "ListBox^.Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03108504, $65766966,   //set property:  "ListBox^.Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03108603, $00786973,   //set property:  "ListBox^.Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03108705, $65766573, $0000006E,   //set property:  "ListBox^.Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03108805, $68676965, $00000074,   //set property:  "ListBox^.Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03108904, $656E696E,   //set property:  "ListBox^.Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03108A03, $006E6574,   //set property:  "ListBox^.Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03100B02, $0000000F,   //set property:  "ListBox^.Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03100E02, $0000000A,   //set property:  "ListBox^.Items^.Count" of "INTEGER" to "10".   Property index: 14
      // Property ListBox^.Items^.TotalVisibleCount skipped because of compiler directives.
      // Property ListBox^.Items^.OnGetItem skipped because of compiler directives.

      $01084405, $004D00C1, $00180050,   //create Label4(5, 193, 77, 80, 24)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03088108, $74696445, $656C6261,   //set property:  "Caption" of "STRING" to "Editable".   Property index: 1
      $03080204, $00000659,   //set property:  "Color" of "TCOLOR" to "00000659".   Property index: 2
      $03080304, $0000FFFF,   //set property:  "Font_Color" of "TCOLOR" to "0000FFFF".   Property index: 3

      $01084405, $001D00C1, $00180082,   //create Label5(5, 193, 29, 130, 24)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03080004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $0308810F, $656C6553, $62617463, $6F20656C, $00796C6E,   //set property:  "Caption" of "STRING" to "Selectable only".   Property index: 1
      $03080204, $00000659,   //set property:  "Color" of "TCOLOR" to "00000659".   Property index: 2
      $03080304, $0000FFFF,   //set property:  "Font_Color" of "TCOLOR" to "0000FFFF".   Property index: 3

      $01074405, $00850009, $007800A0,   //create ListBox2(5, 9, 133, 160, 120)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03070004, $0000079E,   //set property:  "Items^.BackgroundColor" of "TCOLOR" to "0000079E".   Property index: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C02, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01074405, $008500F9, $007800A0,   //create ListBox4(5, 249, 133, 160, 120)  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03070004, $0000079E,   //set property:  "Items^.BackgroundColor" of "TCOLOR" to "0000079E".   Property index: 0
      $03078103, $00656E6F,   //set property:  "Items^.Strings[0]" of "STRING" to "one".   Property index: 1
      $03078203, $006F7774,   //set property:  "Items^.Strings[1]" of "STRING" to "two".   Property index: 2
      $03078305, $65726874, $00000065,   //set property:  "Items^.Strings[2]" of "STRING" to "three".   Property index: 3
      $03078404, $72756F66,   //set property:  "Items^.Strings[3]" of "STRING" to "four".   Property index: 4
      $03078504, $65766966,   //set property:  "Items^.Strings[4]" of "STRING" to "five".   Property index: 5
      $03078603, $00786973,   //set property:  "Items^.Strings[5]" of "STRING" to "six".   Property index: 6
      $03078705, $65766573, $0000006E,   //set property:  "Items^.Strings[6]" of "STRING" to "seven".   Property index: 7
      $03078805, $68676965, $00000074,   //set property:  "Items^.Strings[7]" of "STRING" to "eight".   Property index: 8
      $03078904, $656E696E,   //set property:  "Items^.Strings[8]" of "STRING" to "nine".   Property index: 9
      $03078A03, $006E6574,   //set property:  "Items^.Strings[9]" of "STRING" to "ten".   Property index: 10
      $03070B02, $0000000F,   //set property:  "Items^.ItemHeight" of "WORD" to "15".   Property index: 11
      $03070C02, $0000000A,   //set property:  "Items^.Count" of "INTEGER" to "10".   Property index: 12
      // Property Items^.TotalVisibleCount skipped because of compiler directives.
      // Property Items^.OnGetItem skipped because of compiler directives.

      $01114506, $00210009, $001800C8,   //create TrackBar1(6, 9, 33, 200, 24)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03110002, $00000003,   //set property:  "Position" of "INTEGER" to "3".   Property index: 0
      $03110104, $9D01B030,   //set property:  "OnTrackBarChange" of "PBYTE" to "TrackBar1_OnTrackBarChange".   Property index: 1

      $01114506, $005D0019, $00A00018,   //create TrackBar2(6, 25, 93, 24, 160)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03110002, $00000007,   //set property:  "Position" of "INTEGER" to "7".   Property index: 0
      $03110201, $00000001,   //set property:  "Orientation" of "BYTE" to "CTrackBarVertDir".   Property index: 2
      $03110104, $9D01B2F4,   //set property:  "OnTrackBarChange" of "PBYTE" to "TrackBar2_OnTrackBarChange".   Property index: 1

      $01124506, $002D0101, $001400CC,   //create ProgressBar1(6, 257, 45, 204, 20)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03120004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03120102, $00000003,   //set property:  "Position" of "INTEGER" to "3".   Property index: 1

      $01124506, $005D0101, $00A00018,   //create ProgressBar2(6, 257, 93, 24, 160)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $03120004, $00000000,   //set property:  "BaseProps.CanHandleMessages" of "BOOLEAN" to "False".   Property index: 0
      $03120102, $00000007,   //set property:  "Position" of "INTEGER" to "7".   Property index: 1
      $03120201, $00000001,   //set property:  "Orientation" of "BYTE" to "CProgressBarVertDir".   Property index: 2

      $01014506, $00C80049, $00190068,   //create btnShowMessageBox(6, 73, 200, 104, 25)  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0301800B, $7373654D, $20656761, $00786F42,   //set property:  "Caption" of "STRING" to "Message Box".   Property index: 0
      $03010504, $9D01B078,   //set property:  "BaseProps.OnMouseUpUser" of "PBYTE" to "btnShowMessageBox_OnMouseUpUser".   Property index: 5
      0  //stop execution
    );
  {$ENDIF} {$ENDIF} // IsMCU PIC32AppDWithSDCard

  {$IFDEF IsDesktop} {$IFDEF DesktopApp_D2006} // Profile: "DesktopApp_D2006"
    C_RTTI_DestroyInstructionData: array[0..40] of DWord = (
      $0400000E,   //Set build number to 14
      $02014000,   //destroy btn1 at index 0  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02014001,   //destroy btn2 at index 1  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024002,   //destroy Arrow1 at index 2  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024003,   //destroy Arrow2 at index 3  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024004,   //destroy Arrow3 at index 4  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024005,   //destroy Arrow4 at index 5  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02034006,   //destroy Panel1 at index 6  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024007,   //destroy Arrow5 at index 7  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024008,   //destroy Arrow6 at index 8  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024009,   //destroy Arrow7 at index 9  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0202400A,   //destroy Arrow8 at index 10  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0201400B,   //destroy btn3 at index 11  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0201400C,   //destroy btn4 at index 12  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0202400D,   //destroy Arrow9 at index 13  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0204410E,   //destroy CheckBox1 at index 14  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0204410F,   //destroy CheckBox2 at index 15  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02044110,   //destroy CheckBox3 at index 16  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02054111,   //destroy ScrollBar1 at index 17  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02054112,   //destroy ScrollBar2 at index 18  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074113,   //destroy ListBox1 at index 19  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074114,   //destroy ListBox3 at index 20  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02014115,   //destroy DynTFTButton0 at index 21  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084216,   //destroy lbl1 at index 22  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084217,   //destroy lbl2 at index 23  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084218,   //destroy lbl3 at index 24  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084219,   //destroy lbl4 at index 25  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $020F431A,   //destroy vkTest at index 26  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $020D431B,   //destroy Edit1 at index 27  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0210441C,   //destroy ComboBox1 at index 28  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0210441D,   //destroy ComboBox2 at index 29  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0208441E,   //destroy Label4 at index 30  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0208441F,   //destroy Label5 at index 31  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074420,   //destroy ListBox2 at index 32  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074421,   //destroy ListBox4 at index 33  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02114522,   //destroy TrackBar1 at index 34  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02114523,   //destroy TrackBar2 at index 35  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02124524,   //destroy ProgressBar1 at index 36  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02124525,   //destroy ProgressBar2 at index 37  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02014526,   //destroy btnShowMessageBox at index 38  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      0  //stop execution
    );
  {$ENDIF} {$ENDIF} // IsDesktop DesktopApp_D2006

  {$IFDEF IsMCU} {$IFDEF PIC32App} // Profile: "PIC32App"
    C_RTTI_DestroyInstructionData: array[0..40] of DWord = (
      $04000005,   //Set build number to 5
      $02014000,   //destroy btn1 at index 0  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02014001,   //destroy btn2 at index 1  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024002,   //destroy Arrow1 at index 2  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024003,   //destroy Arrow2 at index 3  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024004,   //destroy Arrow3 at index 4  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024005,   //destroy Arrow4 at index 5  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02034006,   //destroy Panel1 at index 6  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024007,   //destroy Arrow5 at index 7  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024008,   //destroy Arrow6 at index 8  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024009,   //destroy Arrow7 at index 9  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0202400A,   //destroy Arrow8 at index 10  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0201400B,   //destroy btn3 at index 11  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0201400C,   //destroy btn4 at index 12  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0202400D,   //destroy Arrow9 at index 13  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0204410E,   //destroy CheckBox1 at index 14  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0204410F,   //destroy CheckBox2 at index 15  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02044110,   //destroy CheckBox3 at index 16  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02054111,   //destroy ScrollBar1 at index 17  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02054112,   //destroy ScrollBar2 at index 18  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074113,   //destroy ListBox1 at index 19  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074114,   //destroy ListBox3 at index 20  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02014115,   //destroy DynTFTButton0 at index 21  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084216,   //destroy lbl1 at index 22  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084217,   //destroy lbl2 at index 23  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084218,   //destroy lbl3 at index 24  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084219,   //destroy lbl4 at index 25  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $020F431A,   //destroy vkTest at index 26  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $020D431B,   //destroy Edit1 at index 27  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0210441C,   //destroy ComboBox1 at index 28  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0210441D,   //destroy ComboBox2 at index 29  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0208441E,   //destroy Label4 at index 30  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0208441F,   //destroy Label5 at index 31  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074420,   //destroy ListBox2 at index 32  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074421,   //destroy ListBox4 at index 33  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02114522,   //destroy TrackBar1 at index 34  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02114523,   //destroy TrackBar2 at index 35  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02124524,   //destroy ProgressBar1 at index 36  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02124525,   //destroy ProgressBar2 at index 37  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02014526,   //destroy btnShowMessageBox at index 38  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      0  //stop execution
    );
  {$ENDIF} {$ENDIF} // IsMCU PIC32App

  {$IFDEF IsDesktop} {$IFDEF DesktopApp_D10_2} // Profile: "DesktopApp_D10_2"
    C_RTTI_DestroyInstructionData: array[0..40] of DWord = (
      $04000003,   //Set build number to 3
      $02014000,   //destroy btn1 at index 0  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02014001,   //destroy btn2 at index 1  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024002,   //destroy Arrow1 at index 2  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024003,   //destroy Arrow2 at index 3  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024004,   //destroy Arrow3 at index 4  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024005,   //destroy Arrow4 at index 5  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02034006,   //destroy Panel1 at index 6  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024007,   //destroy Arrow5 at index 7  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024008,   //destroy Arrow6 at index 8  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024009,   //destroy Arrow7 at index 9  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0202400A,   //destroy Arrow8 at index 10  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0201400B,   //destroy btn3 at index 11  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0201400C,   //destroy btn4 at index 12  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0202400D,   //destroy Arrow9 at index 13  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0204410E,   //destroy CheckBox1 at index 14  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0204410F,   //destroy CheckBox2 at index 15  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02044110,   //destroy CheckBox3 at index 16  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02054111,   //destroy ScrollBar1 at index 17  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02054112,   //destroy ScrollBar2 at index 18  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074113,   //destroy ListBox1 at index 19  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074114,   //destroy ListBox3 at index 20  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02014115,   //destroy DynTFTButton0 at index 21  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084216,   //destroy lbl1 at index 22  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084217,   //destroy lbl2 at index 23  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084218,   //destroy lbl3 at index 24  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084219,   //destroy lbl4 at index 25  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $020F431A,   //destroy vkTest at index 26  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $020D431B,   //destroy Edit1 at index 27  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0210441C,   //destroy ComboBox1 at index 28  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0210441D,   //destroy ComboBox2 at index 29  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0208441E,   //destroy Label4 at index 30  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0208441F,   //destroy Label5 at index 31  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074420,   //destroy ListBox2 at index 32  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074421,   //destroy ListBox4 at index 33  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02114522,   //destroy TrackBar1 at index 34  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02114523,   //destroy TrackBar2 at index 35  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02124524,   //destroy ProgressBar1 at index 36  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02124525,   //destroy ProgressBar2 at index 37  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02014526,   //destroy btnShowMessageBox at index 38  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      0  //stop execution
    );
  {$ENDIF} {$ENDIF} // IsDesktop DesktopApp_D10_2

  {$IFDEF IsDesktop} {$IFDEF DesktopApp_FP} // Profile: "DesktopApp_FP"
    C_RTTI_DestroyInstructionData: array[0..40] of DWord = (
      $04000004,   //Set build number to 4
      $02014000,   //destroy btn1 at index 0  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02014001,   //destroy btn2 at index 1  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024002,   //destroy Arrow1 at index 2  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024003,   //destroy Arrow2 at index 3  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024004,   //destroy Arrow3 at index 4  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024005,   //destroy Arrow4 at index 5  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02034006,   //destroy Panel1 at index 6  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024007,   //destroy Arrow5 at index 7  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024008,   //destroy Arrow6 at index 8  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024009,   //destroy Arrow7 at index 9  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0202400A,   //destroy Arrow8 at index 10  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0201400B,   //destroy btn3 at index 11  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0201400C,   //destroy btn4 at index 12  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0202400D,   //destroy Arrow9 at index 13  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0204410E,   //destroy CheckBox1 at index 14  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0204410F,   //destroy CheckBox2 at index 15  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02044110,   //destroy CheckBox3 at index 16  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02054111,   //destroy ScrollBar1 at index 17  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02054112,   //destroy ScrollBar2 at index 18  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074113,   //destroy ListBox1 at index 19  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074114,   //destroy ListBox3 at index 20  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02014115,   //destroy DynTFTButton0 at index 21  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084216,   //destroy lbl1 at index 22  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084217,   //destroy lbl2 at index 23  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084218,   //destroy lbl3 at index 24  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084219,   //destroy lbl4 at index 25  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $020F431A,   //destroy vkTest at index 26  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $020D431B,   //destroy Edit1 at index 27  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0210441C,   //destroy ComboBox1 at index 28  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0210441D,   //destroy ComboBox2 at index 29  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0208441E,   //destroy Label4 at index 30  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0208441F,   //destroy Label5 at index 31  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074420,   //destroy ListBox2 at index 32  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074421,   //destroy ListBox4 at index 33  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02114522,   //destroy TrackBar1 at index 34  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02114523,   //destroy TrackBar2 at index 35  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02124524,   //destroy ProgressBar1 at index 36  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02124525,   //destroy ProgressBar2 at index 37  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02014526,   //destroy btnShowMessageBox at index 38  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      0  //stop execution
    );
  {$ENDIF} {$ENDIF} // IsDesktop DesktopApp_FP

  {$IFDEF IsMCU} {$IFDEF PIC32AppAddrArr} // Profile: "PIC32AppAddrArr"
    C_RTTI_DestroyInstructionData: array[0..40] of DWord = (
      $04000020,   //Set build number to 32
      $02014000,   //destroy btn1 at index 0  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02014001,   //destroy btn2 at index 1  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024002,   //destroy Arrow1 at index 2  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024003,   //destroy Arrow2 at index 3  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024004,   //destroy Arrow3 at index 4  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024005,   //destroy Arrow4 at index 5  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02034006,   //destroy Panel1 at index 6  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024007,   //destroy Arrow5 at index 7  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024008,   //destroy Arrow6 at index 8  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024009,   //destroy Arrow7 at index 9  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0202400A,   //destroy Arrow8 at index 10  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0201400B,   //destroy btn3 at index 11  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0201400C,   //destroy btn4 at index 12  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0202400D,   //destroy Arrow9 at index 13  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0204410E,   //destroy CheckBox1 at index 14  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0204410F,   //destroy CheckBox2 at index 15  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02044110,   //destroy CheckBox3 at index 16  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02054111,   //destroy ScrollBar1 at index 17  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02054112,   //destroy ScrollBar2 at index 18  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074113,   //destroy ListBox1 at index 19  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074114,   //destroy ListBox3 at index 20  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02014115,   //destroy DynTFTButton0 at index 21  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084216,   //destroy lbl1 at index 22  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084217,   //destroy lbl2 at index 23  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084218,   //destroy lbl3 at index 24  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084219,   //destroy lbl4 at index 25  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $020F431A,   //destroy vkTest at index 26  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $020D431B,   //destroy Edit1 at index 27  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0210441C,   //destroy ComboBox1 at index 28  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0210441D,   //destroy ComboBox2 at index 29  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0208441E,   //destroy Label4 at index 30  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0208441F,   //destroy Label5 at index 31  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074420,   //destroy ListBox2 at index 32  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074421,   //destroy ListBox4 at index 33  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02114522,   //destroy TrackBar1 at index 34  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02114523,   //destroy TrackBar2 at index 35  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02124524,   //destroy ProgressBar1 at index 36  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02124525,   //destroy ProgressBar2 at index 37  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02014526,   //destroy btnShowMessageBox at index 38  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      0  //stop execution
    );
  {$ENDIF} {$ENDIF} // IsMCU PIC32AppAddrArr

  {$IFDEF IsMCU} {$IFDEF PIC32AppWithSDCard} // Profile: "PIC32AppWithSDCard"
    C_RTTI_DestroyInstructionData: array[0..40] of DWord = (
      $04000005,   //Set build number to 5
      $02014000,   //destroy btn1 at index 0  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02014001,   //destroy btn2 at index 1  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024002,   //destroy Arrow1 at index 2  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024003,   //destroy Arrow2 at index 3  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024004,   //destroy Arrow3 at index 4  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024005,   //destroy Arrow4 at index 5  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02034006,   //destroy Panel1 at index 6  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024007,   //destroy Arrow5 at index 7  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024008,   //destroy Arrow6 at index 8  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024009,   //destroy Arrow7 at index 9  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0202400A,   //destroy Arrow8 at index 10  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0201400B,   //destroy btn3 at index 11  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0201400C,   //destroy btn4 at index 12  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0202400D,   //destroy Arrow9 at index 13  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0204410E,   //destroy CheckBox1 at index 14  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0204410F,   //destroy CheckBox2 at index 15  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02044110,   //destroy CheckBox3 at index 16  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02054111,   //destroy ScrollBar1 at index 17  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02054112,   //destroy ScrollBar2 at index 18  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074113,   //destroy ListBox1 at index 19  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074114,   //destroy ListBox3 at index 20  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02014115,   //destroy DynTFTButton0 at index 21  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084216,   //destroy lbl1 at index 22  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084217,   //destroy lbl2 at index 23  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084218,   //destroy lbl3 at index 24  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084219,   //destroy lbl4 at index 25  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $020F431A,   //destroy vkTest at index 26  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $020D431B,   //destroy Edit1 at index 27  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0210441C,   //destroy ComboBox1 at index 28  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0210441D,   //destroy ComboBox2 at index 29  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0208441E,   //destroy Label4 at index 30  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0208441F,   //destroy Label5 at index 31  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074420,   //destroy ListBox2 at index 32  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074421,   //destroy ListBox4 at index 33  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02114522,   //destroy TrackBar1 at index 34  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02114523,   //destroy TrackBar2 at index 35  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02124524,   //destroy ProgressBar1 at index 36  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02124525,   //destroy ProgressBar2 at index 37  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02014526,   //destroy btnShowMessageBox at index 38  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      0  //stop execution
    );
  {$ENDIF} {$ENDIF} // IsMCU PIC32AppWithSDCard

  {$IFDEF IsMCU} {$IFDEF PIC32AppDWithSDCard} // Profile: "PIC32AppDWithSDCard"
    C_RTTI_DestroyInstructionData: array[0..40] of DWord = (
      $04000005,   //Set build number to 5
      $02014000,   //destroy btn1 at index 0  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02014001,   //destroy btn2 at index 1  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024002,   //destroy Arrow1 at index 2  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024003,   //destroy Arrow2 at index 3  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024004,   //destroy Arrow3 at index 4  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024005,   //destroy Arrow4 at index 5  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02034006,   //destroy Panel1 at index 6  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024007,   //destroy Arrow5 at index 7  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024008,   //destroy Arrow6 at index 8  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02024009,   //destroy Arrow7 at index 9  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0202400A,   //destroy Arrow8 at index 10  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0201400B,   //destroy btn3 at index 11  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0201400C,   //destroy btn4 at index 12  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0202400D,   //destroy Arrow9 at index 13  manual creation group: 0.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0204410E,   //destroy CheckBox1 at index 14  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0204410F,   //destroy CheckBox2 at index 15  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02044110,   //destroy CheckBox3 at index 16  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02054111,   //destroy ScrollBar1 at index 17  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02054112,   //destroy ScrollBar2 at index 18  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074113,   //destroy ListBox1 at index 19  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074114,   //destroy ListBox3 at index 20  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02014115,   //destroy DynTFTButton0 at index 21  manual creation group: 1.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084216,   //destroy lbl1 at index 22  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084217,   //destroy lbl2 at index 23  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084218,   //destroy lbl3 at index 24  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02084219,   //destroy lbl4 at index 25  manual creation group: 2.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $020F431A,   //destroy vkTest at index 26  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $020D431B,   //destroy Edit1 at index 27  manual creation group: 3.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0210441C,   //destroy ComboBox1 at index 28  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0210441D,   //destroy ComboBox2 at index 29  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0208441E,   //destroy Label4 at index 30  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $0208441F,   //destroy Label5 at index 31  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074420,   //destroy ListBox2 at index 32  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02074421,   //destroy ListBox4 at index 33  manual creation group: 4.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02114522,   //destroy TrackBar1 at index 34  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02114523,   //destroy TrackBar2 at index 35  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02124524,   //destroy ProgressBar1 at index 36  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02124525,   //destroy ProgressBar2 at index 37  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      $02014526,   //destroy btnShowMessageBox at index 38  manual creation group: 5.  HasVariableInGUIObjects: 1.  CreatedAtStartup: 0
      0  //stop execution
    );
  {$ENDIF} {$ENDIF} // IsMCU PIC32AppDWithSDCard

  {$IFDEF IsDesktop} {$IFDEF DesktopApp_D2006} // Profile: "DesktopApp_D2006"
    C_CreateDynTFTUI_FileName = 'Create_D2006.dyntftui';
    C_DestroyDynTFTUI_FileName = 'Destroy_D2006.dyntftui';
    C_DynTFTUI_BuildNumber = 14;
    C_ProfileIntegerSize = 4;
    C_ProfilePointerSize = 4;
    C_CreateDynTFTUI_DataSourceOption = 1; // 0 = Data from code const,  1 = .dyntftui file.
    C_DestroyDynTFTUI_DataSourceOption = 1; // 0 = Data from code const,  1 = .dyntftui file.
    C_PropertyAddresses_SourceOption = 0; // 0 = lst file,  1 = array of addresses (code const).
  {$ENDIF} {$ENDIF} // IsDesktop DesktopApp_D2006

  {$IFDEF IsMCU} {$IFDEF PIC32App} // Profile: "PIC32App"
    C_CreateDynTFTUI_FileName = 'none'; //a constant, different than '' 
    C_DestroyDynTFTUI_FileName = 'none'; //a constant, different than '' 
    C_DynTFTUI_BuildNumber = 5;
    C_ProfileIntegerSize = 2;
    C_ProfilePointerSize = 4;
    C_CreateDynTFTUI_DataSourceOption = 0; // 0 = Data from code const,  1 = .dyntftui file.
    C_DestroyDynTFTUI_DataSourceOption = 0; // 0 = Data from code const,  1 = .dyntftui file.
    C_PropertyAddresses_SourceOption = 0; // 0 = lst file,  1 = array of addresses (code const).
    // No *.dyntftui files used in this profile.
  {$ENDIF} {$ENDIF} // IsMCU PIC32App

  {$IFDEF IsDesktop} {$IFDEF DesktopApp_D10_2} // Profile: "DesktopApp_D10_2"
    C_CreateDynTFTUI_FileName = 'Create_D10_2.dyntftui';
    C_DestroyDynTFTUI_FileName = 'Destroy_D10_2.dyntftui';
    C_DynTFTUI_BuildNumber = 3;
    C_ProfileIntegerSize = 4;
    C_ProfilePointerSize = 4;
    C_CreateDynTFTUI_DataSourceOption = 0; // 0 = Data from code const,  1 = .dyntftui file.
    C_DestroyDynTFTUI_DataSourceOption = 0; // 0 = Data from code const,  1 = .dyntftui file.
    C_PropertyAddresses_SourceOption = 0; // 0 = lst file,  1 = array of addresses (code const).
  {$ENDIF} {$ENDIF} // IsDesktop DesktopApp_D10_2

  {$IFDEF IsDesktop} {$IFDEF DesktopApp_FP} // Profile: "DesktopApp_FP"
    C_CreateDynTFTUI_FileName = 'Create_FP.dyntftui';
    C_DestroyDynTFTUI_FileName = 'Destroy_FP.dyntftui';
    C_DynTFTUI_BuildNumber = 4;
    C_ProfileIntegerSize = 4;
    C_ProfilePointerSize = 4;
    C_CreateDynTFTUI_DataSourceOption = 1; // 0 = Data from code const,  1 = .dyntftui file.
    C_DestroyDynTFTUI_DataSourceOption = 1; // 0 = Data from code const,  1 = .dyntftui file.
    C_PropertyAddresses_SourceOption = 0; // 0 = lst file,  1 = array of addresses (code const).
  {$ENDIF} {$ENDIF} // IsDesktop DesktopApp_FP

  {$IFDEF IsMCU} {$IFDEF PIC32AppAddrArr} // Profile: "PIC32AppAddrArr"
    C_CreateDynTFTUI_FileName = 'none'; //a constant, different than '' 
    C_DestroyDynTFTUI_FileName = 'none'; //a constant, different than '' 
    C_DynTFTUI_BuildNumber = 32;
    C_ProfileIntegerSize = 2;
    C_ProfilePointerSize = 4;
    C_CreateDynTFTUI_DataSourceOption = 0; // 0 = Data from code const,  1 = .dyntftui file.
    C_DestroyDynTFTUI_DataSourceOption = 0; // 0 = Data from code const,  1 = .dyntftui file.
    C_PropertyAddresses_SourceOption = 1; // 0 = lst file,  1 = array of addresses (code const).
    // No *.dyntftui files used in this profile.
  {$ENDIF} {$ENDIF} // IsMCU PIC32AppAddrArr

  {$IFDEF IsMCU} {$IFDEF PIC32AppWithSDCard} // Profile: "PIC32AppWithSDCard"
    C_CreateDynTFTUI_FileName = 'C.dyntftui';
    C_DestroyDynTFTUI_FileName = 'D.dyntftui';
    C_DynTFTUI_BuildNumber = 5;
    C_ProfileIntegerSize = 2;
    C_ProfilePointerSize = 4;
    C_CreateDynTFTUI_DataSourceOption = 1; // 0 = Data from code const,  1 = .dyntftui file.
    C_DestroyDynTFTUI_DataSourceOption = 1; // 0 = Data from code const,  1 = .dyntftui file.
    C_PropertyAddresses_SourceOption = 0; // 0 = lst file,  1 = array of addresses (code const).
  {$ENDIF} {$ENDIF} // IsMCU PIC32AppWithSDCard

  {$IFDEF IsMCU} {$IFDEF PIC32AppDWithSDCard} // Profile: "PIC32AppDWithSDCard"
    C_CreateDynTFTUI_FileName = 'C_D.dyntftui';
    C_DestroyDynTFTUI_FileName = 'D_D.dyntftui';
    C_DynTFTUI_BuildNumber = 5;
    C_ProfileIntegerSize = 2;
    C_ProfilePointerSize = 4;
    C_CreateDynTFTUI_DataSourceOption = 1; // 0 = Data from code const,  1 = .dyntftui file.
    C_DestroyDynTFTUI_DataSourceOption = 1; // 0 = Data from code const,  1 = .dyntftui file.
    C_PropertyAddresses_SourceOption = 0; // 0 = lst file,  1 = array of addresses (code const).
  {$ENDIF} {$ENDIF} // IsMCU PIC32AppDWithSDCard


  {$IFDEF IsDesktop}
    CAllCreatedBinComponents: array[0..38] of ^PDynTFTBaseComponent = (
      @btn1, // index: 0
      @btn2, // index: 1
      @Arrow1, // index: 2
      @Arrow2, // index: 3
      @Arrow3, // index: 4
      @Arrow4, // index: 5
      @Panel1, // index: 6
      @Arrow5, // index: 7
      @Arrow6, // index: 8
      @Arrow7, // index: 9
      @Arrow8, // index: 10
      @btn3, // index: 11
      @btn4, // index: 12
      @Arrow9, // index: 13
      @CheckBox1, // index: 14
      @CheckBox2, // index: 15
      @CheckBox3, // index: 16
      @ScrollBar1, // index: 17
      @ScrollBar2, // index: 18
      @ListBox1, // index: 19
      @ListBox3, // index: 20
      @DynTFTButton0, // index: 21
      @lbl1, // index: 22
      @lbl2, // index: 23
      @lbl3, // index: 24
      @lbl4, // index: 25
      @vkTest, // index: 26
      @Edit1, // index: 27
      @ComboBox1, // index: 28
      @ComboBox2, // index: 29
      @Label4, // index: 30
      @Label5, // index: 31
      @ListBox2, // index: 32
      @ListBox4, // index: 33
      @TrackBar1, // index: 34
      @TrackBar2, // index: 35
      @ProgressBar1, // index: 36
      @ProgressBar2, // index: 37
      @btnShowMessageBox // index: 38
    );
  {$ELSE}
    CAllCreatedBinComponents: array[0..38] of ^PDynTFTBaseComponent = (
      PPtr(@btn1), // index: 0
      PPtr(@btn2), // index: 1
      PPtr(@Arrow1), // index: 2
      PPtr(@Arrow2), // index: 3
      PPtr(@Arrow3), // index: 4
      PPtr(@Arrow4), // index: 5
      PPtr(@Panel1), // index: 6
      PPtr(@Arrow5), // index: 7
      PPtr(@Arrow6), // index: 8
      PPtr(@Arrow7), // index: 9
      PPtr(@Arrow8), // index: 10
      PPtr(@btn3), // index: 11
      PPtr(@btn4), // index: 12
      PPtr(@Arrow9), // index: 13
      PPtr(@CheckBox1), // index: 14
      PPtr(@CheckBox2), // index: 15
      PPtr(@CheckBox3), // index: 16
      PPtr(@ScrollBar1), // index: 17
      PPtr(@ScrollBar2), // index: 18
      PPtr(@ListBox1), // index: 19
      PPtr(@ListBox3), // index: 20
      PPtr(@DynTFTButton0), // index: 21
      PPtr(@lbl1), // index: 22
      PPtr(@lbl2), // index: 23
      PPtr(@lbl3), // index: 24
      PPtr(@lbl4), // index: 25
      PPtr(@vkTest), // index: 26
      PPtr(@Edit1), // index: 27
      PPtr(@ComboBox1), // index: 28
      PPtr(@ComboBox2), // index: 29
      PPtr(@Label4), // index: 30
      PPtr(@Label5), // index: 31
      PPtr(@ListBox2), // index: 32
      PPtr(@ListBox4), // index: 33
      PPtr(@TrackBar1), // index: 34
      PPtr(@TrackBar2), // index: 35
      PPtr(@ProgressBar1), // index: 36
      PPtr(@ProgressBar2), // index: 37
      PPtr(@btnShowMessageBox) // index: 38
    );
  {$ENDIF}
{$ENDIF} // RTTIREG


implementation

procedure PDynTFTRadioGroup_CreateRadioButton(Left, Top, Width, Height: Integer; {$IFDEF IsMCU} var {$ENDIF}Caption: string; Parent: PDynTFTRadioGroup);
var
  radbtn: PDynTFTRadioButton;
begin
  radbtn := DynTFTRadioButton_Create(Parent^.BaseProps.ScreenIndex, Left, Top, Width, Height);
  radbtn^.Caption := Caption;
  DynTFTAddRadioButtonToRadioGroup(Parent, radbtn);
end;

procedure PDynTFTRadioGroup_CreateAllRadioButtons(Left, Top, Width, Height, ButtonCount: Integer; Parent: PDynTFTRadioGroup; {$IFDEF IsMCU}var Captions: TRadioButtonCaptionArr{$ELSE} const Captions: array of TRadioButtonCaption{$ENDIF});
var
  i, ButtonCount_1: Integer;
begin
  ButtonCount_1 := ButtonCount - 1;
  for i := 0 to ButtonCount_1 do
    PDynTFTRadioGroup_CreateRadioButton(Left, Top + i * Height, Width, Height, Captions[i], Parent);
end;

procedure PDynTFTPageControl_CreateTabButton(Left, Top, Width, Height: Integer; {$IFDEF IsMCU} var {$ENDIF}Caption: string; Parent: PDynTFTPageControl);
var
  tabbtn: PDynTFTTabButton;
begin
  tabbtn := DynTFTTabButton_Create(Parent^.BaseProps.ScreenIndex, Left, Top, Width, Height);
  tabbtn^.Caption := Caption;
  DynTFTAddTabButtonToPageControl(Parent, tabbtn);
end;

procedure PDynTFTPageControl_CreateAllTabButtonsAsHorizontal(Left, Top, Height, PageCount: Integer; {$IFDEF IsMCU}var Lefts, Widths: TTabButtonIntegerArr {$ELSE} const Lefts, Widths: array of Integer{$ENDIF}; Parent: PDynTFTPageControl; {$IFDEF IsMCU}var Captions: TTabButtonCaptionArr{$ELSE} const Captions: array of TTabButtonCaption{$ENDIF});
var
  i, ButtonCount_1: Integer;
begin
  ButtonCount_1 := PageCount - 1;
  for i := 0 to ButtonCount_1 do

    PDynTFTPageControl_CreateTabButton(Left + Lefts[i], Top, Widths[i], Height, Captions[i], Parent);
end;

procedure PDynTFTPageControl_CreateAllTabButtonsAsVertical(Left, Top, Width, Height, PageCount: Integer; Parent: PDynTFTPageControl; {$IFDEF IsMCU}var Captions: TTabButtonCaptionArr{$ELSE} const Captions: array of TTabButtonCaption{$ENDIF});
var
  i, ButtonCount_1: Integer;
begin
  ButtonCount_1 := PageCount - 1;
  for i := 0 to ButtonCount_1 do
    PDynTFTPageControl_CreateTabButton(Left, Top + i * Height, Width, Height, Captions[i], Parent);
end;

end.
